#pragma once

#include "CCSkillInfo.h"

#pragma pack(1)


#define ITEMTYPE_EQUIPMENT 2
#define ITEMTYPE_SOULSHOT 3
#define ITEMTYPE_SPIRITSHOT 4

#define BODYPART_BHAND 0x4000
#define BODYPART_CLOAK 0x2000 
#define BODYPART_BOOTS 0x1000
#define BODYPART_LBODY 0x800
#define BODYPART_UBODY 0x400
#define BODYPART_GLOVES 0x200
#define BODYPART_LHAND 0x100
#define BODYPART_RHAND 0x80
#define BODYPART_HEAD 0x40
#define BODYPART_FINGERS 0x30
#define BODYPART_EARS 0x6
#define BODYPART_NECK 0x4
#define BODYPART_UNDERWEAR 0x1

#define PAPERDOLL_UNDER 0
#define PAPERDOLL_REAR 1
#define PAPERDOLL_LEAR 2
#define PAPERDOLL_NECK 3
#define PAPERDOLL_RFINGER 4
#define PAPERDOLL_LFINGER 5
#define PAPERDOLL_HEAD 6
#define PAPERDOLL_RHAND 7
#define PAPERDOLL_LHAND 8
#define PAPERDOLL_GLOVES 9
#define PAPERDOLL_CHEST 10
#define PAPERDOLL_LEGS 11
#define PAPERDOLL_FEET 12
#define PAPERDOLL_BACK 13
#define PAPERDOLL_LRHAND 14
#define PAPERDOLL_HAIR 15

class CItemData
{
public:
	int Unknown00; //00
	int Unknown04; //00
	int Unknown08; //00
	int Unknown0C; //00
	int Unknown10; //00
	int Unknown14; //00
	int Unknown18; //00
	int Unknown1C; //00
	int Unknown20; //00
	int nInventoryIndex; //used in CInventory::FirstNextItemByClassID
	int Unknown28; //00
	int Unknown2C; //00
	int Unknown30; //00
	int Unknown34; //00
	int Unknown38; //00
	int Unknown3C; //00
	int Unknown40; //00
	int Unknown44; //00
	int Unknown48; //00
	int Unknown4C; //00
	int Unknown50; //00
	int Unknown54; //00
	int Unknown58; //00
	int Unknown5C; //00
	int Unknown60; //00
	int Unknown64; //00
	int Unknown68; //00
	int Unknown6C; //00
	int nCount; //70
	int nUnknown1; //74
	int nItemID; //78
	int nUnknown2; //7C
	int nBodyPart; //80
	int nUnknown3; //84
	int nUnknown4; //88
	int nUnknown5; //8C
	int nEnchant; //90
};

class CItemInfo
{
public:
	int nUnknown1; //00
	int nType; //04  1 = etc 2 = Equipnemt 3 = SoulShot 4 = SpiritShot
	int nEtcType; //08
	int nWeight; //0C
	int nPrice; //10
	int nDefaultPrice; //14
	CSkillKey ItemSkill; //18
	CSkillKey CriticalSkill; //1C
	int nArmorType; //20
	int nMaterialType; //24
	int nConsumeSS; //28
	int nConsumeSpS; //2C
	int nGrade; //30
	int nCrystals; //34
	bool bCanUse; //38
	bool bUnk1; //39
	bool bUnk2; //3A
	bool bUnk3; //3B
	int nEffectiveRange; //3C
	int nInitialCount; //40
	int nMaximumCount; //44
	bool bIsTrade; //48
	bool bIsDrop; //49
	bool bIsDestruct;//4A
	bool bIsMagic; //4B
	int nPhysicalDamage; //4C
	int nRandomDamage; //50
	int nWeaponType; //54
	int nUnknown58; //bIsTrade???
	int nCritical; //5C
	int nAttackRange; //60
	int nDamageRangeP1; //64
	int nDamageRangeP2; //68
	int nDamageRangeP3; //6C
	int nDamageRangeP4; //70
	int nAttackSpeed; //74
	int nReuseDelay; //78
	int nMPConsume; //7C
	int nMagicDamage; //80
	int nDurability; //84
	int nPhysicalDefence; //88
	int nMagicalDefence; //8C
	short nDualFistHitRate; //90
	short nMPBonus; //92
	int nUnk; //94
	double dHitModify; //98
	double dAvoidModify; //A0
	double dShieldDefenceRate; //A8
	double dShieldDefence; //B0

};

class CCItem
{
public:
	int nUnknown00; //00
	int nUnknown04; //04
	int nUnknown08; //08
	int nUnknown0C; //0C
	int nUnknown10; //10
	int nUnknown14; //14
	int nObjectID; //18
	int nItemID; //1C
	int nUnknown20; //20
	int nUnknown24; //24
	CItemData *pData; //28 - !!! not initialized in many cases
	CItemInfo *pInfo; //2C - !!! not initialized in many cases
	int nUnknown1; //30
	
	CItemInfo *GetInfo();
	
	int GetObjectID()
	{
		return nObjectID;
	}

	int GetItemID()
	{
		return nItemID;
	}

};

#pragma pack()

//smeli temp
//EXPORT CCItem *_FindItemBySID(int sid);
//EXPORT CCItem *_GetItemObject(int sid);