

/*
Guide to C1 olympiad

There is 3 types of competitions:
1. clan competitions of 3 categories: knights, supports, damage dealers
knight classes are: paladin, dark avenger, temple knight, shilien knight, dwarf :)
supports are: prophet, bishop, eva elder, shilien elder, overlord, warcryer
damage dealers - all other classes
2. clan competition of 3x3 parties - no class restrictions
3. individal competition - no class restrictions

clan member can register only to 2 competitions, and to the 1st competition can register only 1 person from clan for each class
individual player can register only to the 3rd one


only 4 level clans can participate 
only 2nd class transfer characters can participate
competition will occour every 2 weeks

---
Registering procedure

When olympiad will be announced, you can start to register until the end of olympiad.
If you for some reasons relogin - must choose "relogin in olympiad" option at NPC
If relogined in stadium - you will automatically lose fight.







there will be maximum total ammount of heros per server: 7; minimum: 0

*/



/*
Determining the Hero

Following a month-long PvP competition, the Hero is selected according to Olympiad points, 
and the Hero retains the title throughout the duration of the next months competition. 
The Hero is determined on the first day of every month.

The Hero will be the individual who has accumulated the most Olympiad points according to their main class, 
has competed more than 5 times in that period, and claimed at least 1 victory. 
The Hero will be placed in stand-by mode and exclusive abilities and weaponry are removed after the one month period.

For example, even if a player has accumulated the most Olympiad points in the current period, 
if he has competed less than 5 times or has never claimed a victory, he is ineligible to become a Hero; 
it is possible that periods may pass without a Hero being designated.

When two players with the same class have accumulated identical Olympiad points, the one who has 
competed most will be designated Hero.
*/

/*
 Competition Method

1) The Olympiad is classified into two competitions: the class competition and the non-class competition. 
Only members of a certain class can partake in class competitions. 
There are no class restrictions for participating in non-class competitions.

2) Participating in a competition is possible only through the Olympiad Master, 
and the hours of competition are 8:00 PM CST to 12:00 AM CST (8:00 PM GMT+1 to 12:00 AM GMT+1 on the Teon server). 
No competition requests are taken outside of competition hours.

3) Competitors will be matched randomly and summoned to the coliseum for competition.

4) Instructions will be regularly provided through system messages, starting 30 seconds before being 
summoned to the coliseum.

5) The summoned competitors are allotted 45 seconds of preparation time. 
The coliseum will then transform into a battlefield and the competition will begin.

6) The maximum competition time is 3 minutes, and the player whose HP drops to 0 first will lose. 
If no victor has emerged at the 3 minute mark, the character who has inflicted the most damage will 
be determined the winner.

7) Upon completion of the competition, the Olympiad point changes will be announced in a system message and 
the competitors will be returned to the village.

8) During the competition, a character whose HP has reached 0 will merely lose the competition, but not die.

9) Once transported to the coliseum, if a character abnormally leaves the game, he will lose the competition. 
If the server goes down while a competition is in progress, the competition will be nullified and 
the competitors will restart at the villages.

10) Before the competition begins, HP, MP, and CP are all recovered and the pre-existing buffs and debuffs 
will be removed. Any summoned pets will be returned, but the servitors/cubics 
will accompany the player to the coliseum. 
The servitors buffs will also dissolve before the start of the competition.

11. When an Olympiad match cannot be held due to a lack of combatants, the system will notify you of the game delay with an appropriate message. 

12. When being moved to the Olympiad Stadium in the middle of summoning a servitor or cubic, the skill in use is terminated automatically. 

13. When moved to an Olympiad Stadium with the automatic use of Soulshots/Spiritshots or Beast Soulshots/Spiritshots enabled, the automatic use is cancelled. 
*/


/*
 Olympiad Requirements

1) Only players in their main classes are able to compete. 

2) If the character belongs to a party when summoned to the Coliseum to compete, he/she will automatically 
withdraw from the party.

3) Characters with 0 Olympiad points are ineligible to compete.

4) In the Olympiad competitions, no items other than soulshots, spiritshots, Echo Crystals, energy stones, 
and firecrackers are allowed.

5) Recall and Party Recall abilities cannot be used in competition. 

6) Hero skills and clan skills cannot be used in an Olympiad game. 

*/


/*

Olympiad Points

1) At the beginning of each Olympiad period, 18 points are equally awarded to all Noblesse, 
and 3 points each week thereafter.

2) The losers Olympiad points are transferred to the winner upon completion of the competition.

3) Competitors are able to check their current point status with the Grand Olympiad Manager.

4) At the end of competition, if a character has accumulated more than 50 Olympiad points, 
they can be exchanged for Noblesse Gate Passes. The rate of exchange is 1,000 Noblesse 
Gate Passes for 1 Olympiad point.

For example, while 50 Olympiad points is exchangeable for 50,000 Noblesse Gate Passes, 
and 49 Olympiad points are not worth any Noblesse Gate Passes.

5) Noblesse Gate Passes may be used for purchasing items from the Grand Olympiad Manager 
or while teleporting to various locations via the Gatekeeper.

The following items can be purchased from the Olympiad master with Noblesse Gate Passes:

    Blessed Scroll: Enchant Weapon (Grade S): 300,000 Noblesse Gate Passes
    Blessed Scroll: Enchant Weapon (Grade A): 150,000 Noblesse Gate Passes
    Blessed Scroll: Enchant Weapon (Grade B): 70,000 Noblesse Gate Passes
    Blessed Scroll: Enchant Weapon (Grade C): 30,000 Noblesse Gate Passes
    Blessed Scroll: Enchant Weapon (Grade D): 9,000 Noblesse Gate Passes
    Blessed Scroll: Enchant Armor (Grade S): 45,000 Noblesse Gate Passes
    Blessed Scroll: Enchant Armor (Grade A): 18,000 Noblesse Gate Passes
    Blessed Scroll: Enchant Armor (Grade B): 3,500 Noblesse Gate Passes
    Blessed Scroll: Enchant Armor (Grade C): 3,500 Noblesse Gate Passes
    Blessed Scroll: Enchant Armor (Grade D): 1,000 Noblesse Gate Passes

    Scroll: Enchant Weapon (Grade S): 50,000 Noblesse Gate Passes
    Scroll: Enchant Weapon (Grade A): 18,000 Noblesse Gate Passes
    Scroll: Enchant Weapon (Grade B): 5,000 Noblesse Gate Passes
    Scroll: Enchant Weapon (Grade C): 1,100 Noblesse Gate Passes
    Scroll: Enchant Weapon (Grade D): 500 Noblesse Gate Passes
    Scroll: Enchant Armor (Grade S): 5,000 Noblesse Gate Passes
    Scroll: Enchant Armor (Grade A): 2,400 Noblesse Gate Passes
    Scroll: Enchant Armor (Grade B): 800 Noblesse Gate Passes
    Scroll: Enchant Armor (Grade C): 150 Noblesse Gate Passes
    Scroll: Enchant Armor (Grade D): 60 Noblesse Gate Passes

    Secret Book of Giant: 5,000 Noblesse Gate Passes


6. When an Olympiad game ends in a draw, the Olympiad points for PCs on both sides are now reduced. 

*/