
#include "SkillSystem.h"



typedef vector<CBaseSkillEffect *> CSkillInfoList;

typedef vector<CBaseOperateCondition *> CSkillOpCondList;
 
enum SkillOpType
{
        SKILL_fOPCODE(OP_TYPE_A1 = 0,
        SKILL_fOPCODE(OP_TYPE_A2 = 1,
        SKILL_fOPCODE(OP_TYPE_A3 = 2,
        SKILL_fOPCODE(OP_TYPE_A4 = 3,
        SKILL_fOPCODE(OP_TYPE_P = 4,
        SKILL_fOPCODE(OP_TYPE_T = 5,
        SKILL_fOPCODE(OP_TYPE_PP = 6
};
 
enum SkillBasePropery
{
        SKILL_BASE_PRfOPCODE(OP_STR = 1,
        SKILL_BASE_PRfOPCODE(OP_DEX = 2,
        SKILL_BASE_PRfOPCODE(OP_CON = 3,
        SKILL_BASE_PRfOPCODE(OP_INT = 4,
        SKILL_BASE_PRfOPCODE(OP_MEN = 5,
        SKILL_BASE_PRfOPCODE(OP_WIT = 6,
        SKILL_BASE_PRfOPCODE(OP_NONE = 26
};
 
struct CItemContainer
{
        __int64 ary[4];
        __int64 strlen;
};

class CSkillKey
{
	public:
		unsigned short ID;
		char Level;
};

class CSkillInfo 
{
	public:

		wchar_t*			skill_name;		// 00h
		int					skill_id;	// 08h
		int					level;		// 10h
		int					toggle_on;	// 14h





		int					is_magic;		// 18h - case 8, values: 0,1,2
		int					has_i_energy_attack;		// 1Ch  
		SkillOpType			fOPCODE(OP_type;	// 1Ch
		int					dw20;
		int					mp_consume2;	// 24h, case 13
		int					dw28;			// 28h, case 14
		int					dw2c;			// 2Ch,
		CItemContainer		item_consume;	// 30h, case 15, sizeof = 0x28.
		int					dw58;	// 58h, case ???
		int					item_consume_count;	// 5Ch, case 15, item consume?
		int					cast_range;		// 60h
		int					effective_range;	// 64h
		int					ary_dw_68[4];		// 68h, 6Ch, 70h, 74h - case 5
		double				skill_hit_time;	// 78h
		double				skill_cool_time; // 80h
		double				skill_hit_cancel_time; // 88h 
		double				reuse_delay; // 90h, sec*1000
		CSkillOpCondList	operate_cond_list; // 98h
		double				lv_bonus_rate; // B8h, case 25
		int					activate_rate; // C0h
		SkillBasePropery	basic_property; // C4h, case 26
		int					abnormal_time;	// C8h
		int					abnormal_lv;	// CCh
		int					abnormal_type;  // D0h
		int					abnormal_visual_effect; // D4h
		int					attribute;		// D8h, attr_earth=9 and so on...
		int					effect_point;	// DCh;
		int					debuff;			// E0h, (1,2)
		int					next_action;	//E4h;
		int					next_action_is_fake_death; // E8h, bool 
		int					ride_state;		// ECh, bitfield
		CBaseSkillEffect*	consume_effect; // F0h, not list!
		CBaseSkillEffect*	tick_effect;	// F8h, not list!
		CSkillInfoList		pump_effect_list; // 100h
		CSkillInfoList		instant_effect_list; // 120h
		int					target_type;	 // 140h
		int					affect_scope;	 // 144h, affect_scope_stru item1
		int					dw148;			 // 148h, case 43
		int					dw14C;			 // 14Ch, eq -1 if affect_scope==single (0)
		int					ary_dw150[2];	 // 150h, case 40,
		int					dw158;			 // case 42
		int					affect_limit[2]; // 15Ch, 160h 
		int					dw164; // 164h

		/* EXTENDED FUNCTIONS */

		void AddInstantEffect(VOID *pSkillEffect)
		{
			typedef void (__thiscall *_PUSHBACK) (VOID *, VOID *); _PUSHBACK xPush_Back = (_PUSHBACK)0x007A1D60L; //c4 c1=4d3d40??? 
			xPush_Back(&this->instant_effect_list, &pSkillEffect);
		}

		void AddPumptEffect(VOID *pSkillEffect)
		{
			typedef void (__thiscall *_PUSHBACK) (VOID *, VOID *); _PUSHBACK xPush_Back = (_PUSHBACK)0x007A1D60L; //c4
			xPush_Back(&this->pump_effect_list, &pSkillEffect);
		}

		void AddOPCondition(VOID *pOpCondition)
		{
			typedef void (__thiscall *_PUSHBACK) (VOID *, VOID *); _PUSHBACK xPush_Back = (_PUSHBACK)0x009068A0L; //c4
			xPush_Back(&this->operate_cond_list, &pOpCondition);
		}

		static CSkillInfo *GetSkillInfo(int nSkillID, int nLevel)
		{
			typedef CSkillInfo*(__fastcall *__GS)(void*, CSkillKey*);
			__GS _GS = (__GS) 0x004d2190;

			CSkillKey c;
			c.ID = nSkillID;
			c.Level = nLevel;

			CSkillInfo *pSI = _GS((void*)0x01689fd48, &c); //skillDB
			return pSI;
		}
};


class CSkillInfo;

class CSkillAction2
{
	public:
	
	/* 0h */ void* _vtable;
	/* 8h */ int caster_sid;
	/* 0Ch */ int n0Ch;
	/* 10h */ DWORD target_sp; //CObjectSP
	/* 1Ch */ int n1Ch;
	/* 20h */ bool bForce;
	/* 21h */ bool bHasTarget;
	/* 22h */ bool b22h_ary[6];
	/* 28h */ double fOne; // == 1.0
	/* 30h */ char foo30[0x38];
	/* 68h */ CSkillInfo *pSI;
};
