//#include "L2Server.h"
#include "stdafx.h"
#include "L2ExtLog.h"

void CL2ExtLog::Init()
{
char buffer[MAX_PATH];
SYSTEMTIME sysTime;

if(AllocConsole()){
	m_logConsole = CreateFileA("CONOUT$", GENERIC_READ|GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, 0);
	if(SetConsoleMode(m_logConsole, ENABLE_PROCESSED_OUTPUT | ENABLE_WRAP_AT_EOL_OUTPUT )) { SetConsoleTitleA("L2-32bit SINA-2012 server console"); }
}

GetLocalTime(&sysTime);
CreateDirectoryA(".\\L2ExtLog", NULL);
sprintf_s(buffer, MAX_PATH, ".\\L2ExtLog\\log%02d-%02d-%02d-%02d-%04d.log", sysTime.wSecond,sysTime.wMinute,sysTime.wMonth, sysTime.wDay, sysTime.wYear);
m_logFile = CreateFileA(buffer, GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0);

}

void CL2ExtLog::Add(L2ExtLogType logType, const char *format, ...)
{
char buffer[1024], paramBuffer[1024];
DWORD numberOfCharsWritten;

va_list va;
va_start(va, format);
vsnprintf_s(paramBuffer, sizeof(paramBuffer), _TRUNCATE, format, va);
va_end(va);

SYSTEMTIME sysTime;
GetLocalTime(&sysTime);

	if ((m_logConsole) && (logType==CONSOLE_LOG || logType==FULL_LOG))
	{
		_snprintf_s(buffer, sizeof(buffer), _TRUNCATE, "%s\n", paramBuffer);
		SetConsoleTextAttribute(m_logConsole, FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE);
		WriteConsoleA(m_logConsole, buffer, (DWORD)strlen(buffer), &numberOfCharsWritten, NULL);
	}

	if((m_logFile) && (logType==FILE_LOG || logType==FULL_LOG))
	{
		_snprintf_s(buffer, sizeof(buffer), _TRUNCATE, "%02d/%02d/%04d %02d:%02d:%02d %s\r\n", sysTime.wMonth, sysTime.wDay, sysTime.wYear, sysTime.wHour, sysTime.wMinute, sysTime.wSecond, paramBuffer);
		EnterCriticalSection(&m_criticalSection);
		WriteFile(m_logFile, buffer, (DWORD)strlen(buffer), &numberOfCharsWritten, NULL);
		LeaveCriticalSection(&m_criticalSection);
	}
}

CL2ExtLog::CL2ExtLog() : m_logConsole(NULL), m_logFile(NULL)
{
	InitializeCriticalSection(&m_criticalSection);
}

CL2ExtLog::~CL2ExtLog()
{
	DeleteCriticalSection(&m_criticalSection);

	if (m_logConsole)  { FreeConsole(); }
	if (m_logFile)
	{
		FlushFileBuffers(m_logFile);
		CloseHandle(m_logFile);
	}
}

