/* 
 * Lineage II Extension Project - Affectionately known as the L2EP 'Elhaym' Project/DLL
 * Property of Michael Sadlon a.k.a. mcrabben7 [mcrabben7@gmail.com]
 * Team Effort along with RipperX, Annatar, Nevyn, and with some help from others.
 * 
 * The goals of this project are to expand the aging Lineage II Chronicle 1 server
 * to support the functionality in C3 and C4, and is made to work with the C4 client.
 * 
 * This project is open-source.  It is released from time to time by our discretion.
 * Anyone who has this code, or this DLL, and chooses to use it or learn from it frees
 * us from ALL liabilities.  USE AT YOUR OWN RISK.
 * 
 * I have chosen to release this (you can read the license in License.txt) with the caveat
 * that you may NOT sell our work, any derivative of our work, or make a profit in any way
 * related to our work or a derivative of our work WITHOUT OUR EXPRESS PERMISSION.
 * 
 * Please see License.txt for the full details.  Make sure you READ it!
 */

#ifndef _PARTY_
	#include "Party.h"
#endif

//--------------------------------------------------------------------------------------------
//// Function Definitions
//--------------------------------------------------------------------------------------------

void RequestPartyFix(DWORD * pBuffer)
{
	__asm
	{
		mov		ebx, pBuffer
		lea		esi, [ebx+1]
		push	esi
		call	FindUserByCharName
		or		eax, eax
		jz		UserNotFound
		mov		ecx, [eax+18h]
		//Start String Loop
		push	ecx
		add		ebx, 1			//set ebx to point to the first wchar in the string
		xor		eax, eax
		xor		ecx, ecx
	StringLoop:
		cmp		ecx, 16			//if we have searched for 16 characters, give up.
		je		EndStringLoop	//jump so we prevent a buffer overrun attack
		mov		ax, [ebx]		//copy our wchar value
		add		ebx, 2			//move our pointer to the next wchar in the string
		add		ecx, 1
		cmp		ax, 0			//see if this is the null-terminated part of the string
		jnz		StringLoop		//if not, loop and keep searching
	EndStringLoop:
		pop		ecx
		//End String Loop
		mov		eax, [ebx]		//copy lootType
		cmp		eax,1
		jle	done
		mov		eax,1 //C1 have only 0 and 1 distributions (smeli fix)
done:
		mov		ebx, pBuffer
		mov		[ebx+1], ecx			//mov objectID to pBuffer+1
		mov		[ebx+5], eax			//mov lootType to pBuffer+5
		mov		word ptr [ebx+9], 0599h
		//mov		word ptr [ebx+9], 0		//zero out pBuffer+9
		mov		word ptr [ebx-2], 0Bh	//set packet length to 11 bytes
		jmp		RequestPartyFixExit
	UserNotFound:
		xor		eax, eax
		mov		[ebx+1], eax
		mov		[ebx+5], eax
	RequestPartyFixExit:
	}
}


Naked DWORD * FindUserByCharName(DWORD * charName)
{
	__asm
	{
		PUSH EBP
		MOV EBP,ESP
		ADD ESP,-4Ch
		PUSH EBX
		PUSH EDI
		PUSH ESI
		LEA EAX,DWORD PTR SS:[EBP-4Ch]	//our 64 byte buffer
		PUSH EAX
		PUSH DWORD PTR SS:[EBP+8h]		//charName
		CALL TEMPLATE_GET_USER
		ADD ESP,8h
		SUB ESP,124h
		MOV ESI,ESP
		XOR EBX,EBX
		MOV DWORD PTR DS:[ESI+120h],8Bh
		MOV DWORD PTR DS:[ESI+11Ch],EBX
		MOV WORD PTR DS:[ESI+4h],BX
		LEA EDX,DWORD PTR SS:[EBP-4Ch]	//our 64 byte buffer
		PUSH EDX
		CALL TEMPLATE_GET_USER2
		ADD ESP,4
		MOV ECX,ESI
		MOV EDX,EAX
		LEA EAX,DWORD PTR SS:[EBP-4Ch]	//our 64 byte buffer
		PUSH EDX
		PUSH EAX
		CALL TEMPLATE_GET_USER3
		MOV ECX,16922550h
		LEA EAX,DWORD PTR SS:[EBP-0Ch]	//our 12 byte objectID holder
		PUSH EAX
		CALL TEMPLATE_GET_USER4
		MOV EAX,DWORD PTR SS:[EBP-0Ch]	//return our User struct (pUser)
		POP ESI
		POP EDI
		POP EBX
		LEAVE
		RETN 4
	}
}



//------------------------------------------------------------
//corrund fixes
//----------------------------------
/*
Naked void HookEnterPartyBuff()
{
	__asm
	{
PUSHAD
MOV ECX,ESP
MOV EAX,[ECX]
PUSH EAX
CALL EnterPartyBuff
POP EAX
POPAD

POP EBX
MOV ESP,EBP
POP EBP
RET 4

	}

}
Naked void HookPartyBuff()
{
	__asm
	{
		PUSHAD
PUSH ECX
CALL PartyBuff
POP ECX
POPAD

//4f14d0
PUSH EBP
MOV EBP, ESP
PUSH 0FFh //-1
PUSH 004F15D5h
RETN
	}

}


Naked void HookEnterPartyBuffC3()
{
	__asm
	{
PUSHAD
MOV ECX,ESP
MOV EAX,[ECX]
PUSH EAX
CALL EnterPartyBuffC3
POP EAX
POPAD

POP EBX
MOV ESP,EBP
POP EBP
RET 4

	}

}
Naked void HookPartyBuffC3()
{
	__asm
	{
		PUSHAD
PUSH ECX
CALL PartyBuffC3
POP ECX
POPAD

//4f14d0
PUSH EBP
MOV EBP, ESP
PUSH 0FFh //-1
PUSH 004F15D5h
RETN
	}

}


#ifdef __KAMAEL_PACKETS__

Naked void HookEnterPartyBuffCT()
{
	__asm
	{
PUSHAD
MOV ECX,ESP
MOV EAX,[ECX]
PUSH EAX
CALL EnterPartyBuffCT
POP EAX
POPAD

POP EBX
MOV ESP,EBP
POP EBP
RET 4

	}

}
Naked void HookPartyBuffCT()
{
	__asm
	{
		PUSHAD
PUSH ECX
CALL PartyBuffCT
POP ECX
POPAD

//4f14d0
PUSH EBP
MOV EBP, ESP
PUSH 0FFh //-1
PUSH 004F15D5h
RETN
	}

}

#endif
*/
//-------------------------------
//end of corrund fixes




