//	WriteHook(JMP_HOOK,0x00516907, WarehousePrivilegies, 1);
#include "L2Server.h"

static const wchar_t *fnPrivilegies001=L"Elhaym::ExPledge * GetExPledge(DWORD pledgeID)";
ExPledge * GetExPledge(DWORD pledgeID)
{
try { _set_se_translator( trans_func );
	if(pledgeID != 0)
	{
			//ExPledge * tempExPledge = &ExPledgeArray[pledgeID];
			if (pledgeID > EX_PLEDGE_ARRAY_SIZE)	
				return &ExPledgeArray[EX_PLEDGE_ARRAY_SIZE];
			else
				return &ExPledgeArray[pledgeID];
	}
	return &EmptyExPledge;

} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnPrivilegies001,0);
   throw;       // Pass exception to some other handler
}

}


static const wchar_t *fnPrivilegies002=L"Elhaym::int CheckPledgeLevel(DWORD *pUser, int checklevel)";
int CheckPledgeLevel(DWORD *pUser, int checklevel)
{
try { _set_se_translator( trans_func );
	DWORD *pPledge =User::GetPledge(pUser);
	if (pPledge != NULL) {
		PPLEDGESHAREDDATA pledgeSharedDat;// = (PPLEDGESHAREDDATA)GetSharedData2(pPledge);
			_asm
		{
			mov		eax, pPledge
			mov		eax, [eax+028h]
			mov		pledgeSharedDat, eax
		}
		if (pledgeSharedDat != NULL) {

			if (pledgeSharedDat->m_nSkillLevel >= checklevel)
				return 1;
		}
	}
return 0;

} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnPrivilegies002,0);
   throw;       // Pass exception to some other handler
}


}



static const wchar_t *fnPrivilegies003=L"Elhaym::int CheckPledgeMemberWHPrivilegie(DWORD *pUser, DWORD memberSID)";
int CheckPledgeMemberWHPrivilegie(DWORD *pUser, DWORD memberSID)
{
	try { _set_se_translator( trans_func );
	if (memberSID == 0) 
		return 0;

					DWORD *pMember = CCreature::GetCreature(memberSID);
					if ((pUser != pMember) && (pMember != NULL)) 
					{
						PTCharBaseData CSharedDat= (PTCharBaseData)GetSharedData(pMember);
						if (CSharedDat != NULL)
							if ((CSharedDat->m_bIsNPC_in_Clan & PLEDGE_WH_WITHDRAW) > 0)
								return 1; //another warehouse user found
					}
		return 0;


} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnPrivilegies003,0);
   throw;       // Pass exception to some other handler
}


}




static const wchar_t *fnPrivilegies004=L"Elhaym::int CheckPledgeLeaderOnline(DWORD *pUser, bool check4warehouse)";
int CheckPledgeLeaderOnline(DWORD *pUser, bool check4warehouse)
{
	try { _set_se_translator( trans_func );
	DWORD *pPledge =User::GetPledge(pUser);
	if (pPledge != NULL) {
		PPLEDGESHAREDDATA pledgeSharedDat;// = (PPLEDGESHAREDDATA)GetSharedData2(pPledge);
			_asm
		{
			mov		eax, pPledge
			mov		eax, [eax+028h]
			mov		pledgeSharedDat, eax
		}
		if (pledgeSharedDat != NULL) {
			//wchar_t *wszLeaderName = pledgeSharedDat->m_sMasterName;
			DWORD *pLeader = CCreature::GetCreature(pledgeSharedDat->m_nMasterID);
			//PTCharBaseData CSharedDat= (PTCharBaseData)GetSharedData(pLeader);
			if (pLeader != NULL) {
				return 1;
			} else {
				if (check4warehouse) {
				
				//need to check every pledge member for warehouse withdraw privilegie, only one user can be online
					int y;
					switch (pledgeSharedDat->m_nSkillLevel)
					{
					case 0:
						y = PLEDGE_MAX_MEMBERS_L0;
					case 1:
						y = PLEDGE_MAX_MEMBERS_L1;
					case 2:
						y = PLEDGE_MAX_MEMBERS_L2;
					case 3:
						y = PLEDGE_MAX_MEMBERS_L3;
					case 4:
						y = PLEDGE_MAX_MEMBERS_L4;
					case 5:
						y = PLEDGE_MAX_MEMBERS_L5;

					}
					if (y> 40)
						y = 40;

					for (int i = 0; i<y; i++) {
						if (CheckPledgeMemberWHPrivilegie(pUser,pledgeSharedDat->pmembers[i].member_id) == 1) 
															return 4; //another warehouse user found
					}

				} else {
					return 3; //no leader
				}

			}
		} else {
			return 2; //no shared data
		}


	}

return 0; //no pledge

} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnPrivilegies004,0);
   throw;       // Pass exception to some other handler
}


}





static const wchar_t *fnPrivilegies005=L"Elhaym::void BlockPledgeMemberWHPrivilegie(DWORD *pUser, DWORD memberSID, int blockFlags)";
void BlockPledgeMemberWHPrivilegie(DWORD *pUser, DWORD memberSID, int blockFlags)
{
	try { _set_se_translator( trans_func );
	if (memberSID == 0) 
		return;

					DWORD *pMember = CCreature::GetCreature(memberSID);
					if ((pUser != pMember) && (pMember != NULL)) 
					{
						PTCharBaseData CSharedDat= (PTCharBaseData)GetSharedData(pMember);
						if (CSharedDat != NULL)
							//we can only block there, so check blockable first
							if ((CSharedDat->m_bIsNPC_in_Clan & blockFlags) > 0)
								CSharedDat->m_bIsNPC_in_Clan= CSharedDat->m_bIsNPC_in_Clan ^ blockFlags;
					}


} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnPrivilegies005,0);
   throw;       // Pass exception to some other handler
}


}

static const wchar_t *fnPrivilegies006=L"Elhaym::void TempBlockPrivilegies(DWORD *pUser, int blockFlags)";
void TempBlockPrivilegies(DWORD *pUser, int blockFlags)
{
	try { _set_se_translator( trans_func );

	PTCharBaseData CSharedDat = (PTCharBaseData)GetSharedData(pUser);

	if (CSharedDat == NULL)
		return;

	int pledgeID =CSharedDat->nPledgeId;

	if (CSharedDat->nIsPledgeLeader == 0)
		return;

	ExPledge * tempExPledge= GetExPledge(pledgeID);
	if (blockFlags == 0) {
		tempExPledge->BlockPrivilegies = 0;
		return;
	}

	tempExPledge->BlockPrivilegies=tempExPledge->BlockPrivilegies | blockFlags; //block ... privilegies, will be used with "^" (XOR) operator to existing values

	DWORD *pPledge =User::GetPledge(pUser);
	if (pPledge != NULL) {
		PPLEDGESHAREDDATA pledgeSharedDat;// = (PPLEDGESHAREDDATA)GetSharedData2(pPledge);
			_asm
		{
			mov		eax, pPledge
			mov		eax, [eax+028h]
			mov		pledgeSharedDat, eax
		}

		if (pledgeSharedDat != NULL) {
				
				//need to check every pledge member for warehouse withdraw privilegie, only one user can be online
					int y;
					switch (pledgeSharedDat->m_nSkillLevel)
					{
					case 0:
						y = PLEDGE_MAX_MEMBERS_L0;
					case 1:
						y = PLEDGE_MAX_MEMBERS_L1;
					case 2:
						y = PLEDGE_MAX_MEMBERS_L2;
					case 3:
						y = PLEDGE_MAX_MEMBERS_L3;
					case 4:
						y = PLEDGE_MAX_MEMBERS_L4;
					case 5:
						y = PLEDGE_MAX_MEMBERS_L5;
					}
					
					if (y> 40)
						y = 40;

					for (int i = 0; i<y; i++) {
						BlockPledgeMemberWHPrivilegie(pUser,pledgeSharedDat->pmembers[i].member_id, blockFlags);
					}
					
			
		}


	}

} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnPrivilegies006,0);
   throw;       // Pass exception to some other handler
}


}


int CheckViewPrivilegiesPriv(PTCharBaseData CSharedDat)
{
	if (((CSharedDat->m_bIsNPC_in_Clan & PLEDGE_PRIVS_WIEW) > 0) || (CSharedDat->nIsPledgeLeader)) {
		return 1;
	}
	return 0;

}



int CheckWarehousePrivilegies(PTCharBaseData CSharedDat)
{
	//DWORD *pUser;
	//PTCharBaseData CSharedDat= (PTCharBaseData)GetSharedData(pUser);
	//int privilegie = CSharedDat->m_bIsNPC_in_Clan;
	if (((CSharedDat->m_bIsNPC_in_Clan & PLEDGE_WH_WITHDRAW) > 0)) {
		//check for pledge leader online will be in receive packet function
		//405520,	"CPledge *User::GetPledge();
		CSharedDat->m_nRespawnTime = PLEDGE_WH_WITHDRAW; //save pledge warehouse withdrawal flag
		return 1;
	}
	return 0;

}

int CheckTitlePrivilegies(PTCharBaseData CSharedDat, DWORD *pUser)
{
	if (((CSharedDat->m_bIsNPC_in_Clan & PLEDGE_TITLE) > 0) || (CSharedDat->nIsPledgeLeader) ) {
		return 1; //allowed 
	} else {
	//	CSocketOLD::Send((DWORD *)GetParameter(pUser, User::USER_SOCKET), FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 
	//								614, 1 , 0, L"You're not allowed to change clan member title!");
		return 0; //not allowed
	}
}

int CheckJoinPledgePrivilegies(PTCharBaseData CSharedDat, DWORD *pUser)
{
	if (((CSharedDat->m_bIsNPC_in_Clan & PLEDGE_JOIN) > 0) || (CSharedDat->nIsPledgeLeader) ) {
		return 1; //allowed 
	} else {
	//	CSocketOLD::Send((DWORD *)GetParameter(pUser, User::USER_SOCKET), FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 
	//								614, 1 , 0, L"You're not invite person to clan!");
		return 0; //not allowed
	}
}


__declspec(naked) void WarehousePrivilegies()
{
	//..jmp 516907 + 1 nop
	__asm {

		//pledgeSharedData = pPledge+28h
		mov edi,[eax][000000A0h]  //pledgeSharedData->m_nRulerId
		call dword ptr[edx][0000012ch] 
		cmp edi,eax
		je short valid

		//mov		eax, [ebx+0F54h] //this is NPC warehouser
		//19b8 = usersocket
		mov		eax, [esi+0F54h] //player shared data
		//mov		[eax+65Ch],ebx //pWarehouser
		//cmp		eax,0  // is user null

		

		pushad
		push	eax
		//push	esi //pUser
		call	CheckWarehousePrivilegies
		add		esp,4
		cmp		eax,1
		popad
		je		short valid	
/*
		mov		eax, [eax+0660h] // m_bIsNPC_in_Clan, used as privilegies field
		and		eax, 4 //can view warehouse
		cmp		eax,0
		jg		short valid

		mov		eax, [eax+0660h] // m_bIsNPC_in_Clan, used as privilegies field
		and		eax, 8 //can withdrav warehouse
		cmp		eax,0
		jg		short valid
*/


		jmp  short not_valid
valid:
		push 0516933h
		retn
not_valid:
		push 0516917h //"only clan leader enabled" message
		retn


	}
}





__declspec(naked) void TitlePrivilegies()
{
	//50CF60 + 1 nop
	__asm {

//		mov	al,[edx][000002A0h] //CSharedDat->nIsPledgeLeader
//		test al,al
//		je	050d098h


		pushad
		push PLEDGE_TITLE_LEVEL
		push edi //pUser
		call CheckPledgeLevel
		add		esp,8
		cmp		eax,0
		popad
		je	short lowlevel  //not enough pledge level



		pushad
		push	edi //pUser
		push	edx //CSharedDat
		//push	esi //pUser
		call	CheckTitlePrivilegies
		add		esp,8
		cmp		eax,0
		popad
		je	050d098h  //not allowed

		mov	eax,[ebx][028h] //pledgeSharedData
//		cmp	dword ptr[eax][000000e8h],00000003 
//		jae	050CFA1h

//		mov	eax,dword ptr[eax+0E8h]
//		cmp al,3 //PLEDGE_TITLE_LEVEL
//		jl 050CFA1h

		push 050CFA1h
		retn


lowlevel:
		push 050CF7Ah //msg "Title endowment is only possible when clan's skill levels are above 3."
		retn


	}
}



__declspec(naked) void JoinPledgePrivilegies()
{
	//510322 + 1 nop
	__asm {


		pushad
		push	esi //pUser
		mov		edx,[esi][00000F54h]
		push	edx //CSharedDat
		//push	esi //pUser
		call	CheckJoinPledgePrivilegies
		add		esp,8
		cmp		eax,0
		popad
		je	05105b1h  //not allowed



		push 0510336h
		retn


	}
}


__declspec(naked) void JoinPledgeAnswerPrivilegies()
{
	//5106d5 + 1 nop
	__asm {


		pushad
		push	eax //pUser
		mov		edx,[eax][00000F54h]
		push	edx //CSharedDat
		//push	esi //pUser
		call	CheckJoinPledgePrivilegies
		add		esp,8
		cmp		eax,0
		popad
		je	051075eh  //not allowed



		push 05106e3h
		retn


	}
}
