#include "SendPacket.h"

SendPacketCached::SendPacketCached()
: BasePacket( NULL, 0 ) {
}

SendPacketCached::~SendPacketCached() {
}

void SendPacketCached::Write8( const unsigned char Data ) {
	Resize( m_DataLen + 1 );
	memcpy( m_Data + m_DataLen, &Data, 1 );
	++m_DataLen;
}

void SendPacketCached::Write32( const unsigned int Data ) {
	Resize( m_DataLen + 4 );
	memcpy( m_Data + m_DataLen, &Data, 4 );
	m_DataLen += 4;
}

void SendPacketCached::WriteFloat( const float Data ) {
	Resize( m_DataLen + 4 );
	memcpy( m_Data + m_DataLen, &Data, 4 );
	m_DataLen += 4;
}


void SendPacketCached::WriteStr( const char *Data ) {
	size_t StrLen = strlen( Data );
	unsigned short DataLen = ( unsigned short )( StrLen );
	Resize( m_DataLen + DataLen );
	memcpy( m_Data + m_DataLen, Data, DataLen );
	m_DataLen += DataLen;
}


void SendPacketCached::WriteStrUnicode( const char *Data ) {
	size_t StrLen = strlen( Data );
	unsigned short DataLen = ( unsigned short )( StrLen * 2 + 2 );
	wchar_t *UniStr = new wchar_t[ StrLen + 1 ];

	Resize( m_DataLen + DataLen );
	MultiByteToWideChar( CP_ACP, 0, Data, ( int )( StrLen + 1 ), UniStr, ( int )( StrLen + 1 ) );
	memcpy( m_Data + m_DataLen, UniStr, DataLen );
	m_DataLen += DataLen;
}

void SendPacketCached::Finish() {
	/* Add packet len(16bit short) */
	unsigned short NewLen = m_DataLen + 2;
	char *TempData = new char[ NewLen ];

	memcpy( TempData, &NewLen, 2 );
	memcpy( TempData + 2, m_Data, m_DataLen );
	delete m_Data;
	m_Data = TempData;
	m_DataLen += 2;
}

void SendPacketCached::Resize( unsigned short NewLen ) {
	if ( m_Data != NULL ) {
		char *TempData = new char[ NewLen ];

		memcpy( TempData, m_Data, m_DataLen );
		delete m_Data;
		m_Data = TempData;
	} else {
		m_Data = new char[ NewLen ];
	}
}