#pragma once

#define SP_AUTOSS(pSocket,nItemID,nCommand) pSocket->Send("chdd",0xFE,0x12,nItemID,nCommand)

//system messages
#define SP_ID_SYSTEMMESSAGE 0x64
#define SP_SM_NUMBER 1

//=== COMMON MESSAGES ===
//"Nothing happened."
#define SM_NOTHING_HAPPENED 61

//"Target is not found in the game."
#define SM_TARGET_NOT_FOUND 0x91

//===WEIGHT===
// "You cannot move. Your item weight is too great. "
#define SM_CANT_MOVE_WEIGHT_TOO_GREAT 0x22B

//22C "You cannot move in this state."
#define SM_CANT_MOVE_IN_THIS_STATE 0x22C


//=== SOUL/SPIRITSHOT RELATED ===
//"Soulshot does not match weapon grade."
#define SM_SS_NOT_MATCH_WEAPON 0x151 
//"Not enough soulshots."
#define SM_NOT_ENOUGH_SS 0x152
//"Cannot use soulshots."
#define SM_CANT_USE_SS 0x153
//"Spiritshot does not match weapon grade."
#define SM_SPS_NOT_MATCH_WEAPON 0x212
//"Not enough spiritshots."
#define SM_NOT_ENOUGH_SPS 0x213
//"Cannot use spiritshots."
#define SM_CANT_USE_SPS 0x214
//"The use of $s1 will now be automated."
#define SM_USE_S1_AUTOMATED 0x599
//"The automatic use of $s1 will now be cancelled."
#define SM_USE_S1_CANCELED 0x59A

//=== PARTY RELATED ===
//"Wrong target has been invited."
#define SM_WRONG_TARGET_INVITED 0x98
//"$s1 is a member of another party and cannot be invited."
#define SM_S1_MEMBER_OF_ANOTHER_PARTY 0xA0
//"Only the leader can give out invitations."
#define SM_ONLY_LEADER_CAN_GIVE_INVITATIONS 0x9A
//"Party is full."
#define SM_PARTY_IS_FULL 0x9B
//"Waiting for another reply."
#define SM_WAITING_FOR_REPLY 0xA4
//"$s1 is busy. Please try again later."
#define SM_S1_IS_BUSY 0x99
//"Only a party leader can transfer one's rights to another player."
#define SM_ONLY_PARTY_LEADER_CAN_TRANSFER_RIGHTS 0x577
//"You can transfer rights only to another party member."
#define SM_YOU_CAN_TRANSFER_RIGHT_ONLY_TO_ANOTHER_MEMBER 0x57A
//"$s1 has become a party leader."
#define SM_S1_BECOME_PARTY_LEADER 0x568

//=== BLOCKLIST ===
//"$s1  has placed you on his/her Ignore List."
#define SM_S1_HAS_PLACED_YOU_ON_INGNORE_LIST 0x26C

//macros for system messages
#define SP_SM_TEXT(pSocket,nSM) pSocket->Send("cdd",SP_ID_SYSTEMMESSAGE,nSM,0)
#define SP_SM_TEXT_TEXT(pSocket,nSM,szText) pSocket->Send("cdddS",SP_ID_SYSTEMMESSAGE,nSM,1,0,szText)
#define SP_SM_TEXT_NUMBER3(pSocket,nSM,n1,n2,n3) pSocket->Send("cdddddddd",SP_ID_SYSTEMMESSAGE,nSM,3,1,n1,1,n2,1,n3)
#define SP_SM_TEXT_ITEM(pSocket,nSM,nItemID) pSocket->Send("cdddd",SP_ID_SYSTEMMESSAGE,nSM,1,3,nItemID)

//join party packet
#define SP_SM_JOIN_PARTY(pSocket,nResponse) pSocket->Send("cd",0x3A,nResponse)
//AskJoinParty
#define SP_ASK_JOIN_PARTY(pSocket,szRequestorName,nItemDistribution) pSocket->Send("cSd",0x39,szRequestorName,nItemDistribution)

//ActionFailed
#define SP_ACTION_FAILED(pSocket) pSocket->Send("c",0x25)


//status update stuff
#define SP_STATUS_UPDATE 0x0E
#define STATUS_LEVEL 0x01
#define STATUS_EXP 0x02
#define STATUS_STR 0x03
#define STATUS_DEX 0x04
#define STATUS_CON 0x05
#define STATUS_INT 0x06
#define STATUS_WIT 0x07
#define STATUS_MEN 0x08
#define STATUS_CUR_HP 0x09
#define STATUS_MAX_HP 0x0a
#define STATUS_CUR_MP 0x0b
#define STATUS_MAX_MP 0x0c
#define STATUS_SP 0x0d
#define STATUS_CUR_LOAD 0x0e
#define STATUS_MAX_LOAD 0x0f
#define STATUS_P_ATK 0x11
#define STATUS_ATK_SPD 0x12
#define STATUS_P_DEF 0x13
#define STATUS_EVASION 0x14
#define STATUS_ACCURACY 0x15
#define STATUS_CRITICAL 0x16
#define STATUS_M_ATK 0x17
#define STATUS_CAST_SPD 0x18
#define STATUS_M_DEF 0x19
#define STATUS_PVP_FLAG 0x1a
#define STATUS_KARMA 0x1b
#define STATUS_CUR_CP 0x21
#define STATUS_MAX_CP 0x22
