#include "TCPBaseSocket.h"

TCPBaseSocket::TCPBaseSocket()
{
	m_Socket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
}

TCPBaseSocket::TCPBaseSocket(SOCKET &Socket, SOCKADDR_IN &AddrIn)
: m_Socket(Socket), m_AddrIn(AddrIn)
{}

TCPBaseSocket::~TCPBaseSocket()
{
	Close();
}

bool TCPBaseSocket::Init(WORD wRequestedWinsockVersion)
{
	WSAStartup(wRequestedWinsockVersion, &m_WsaData);

	if (m_WsaData.wVersion != wRequestedWinsockVersion)
		return false;

	return true;
}

void TCPBaseSocket::DeInit()
{
	WSACleanup();
}

WSADATA TCPBaseSocket::GetWsaData()
{
	return m_WsaData;
}

void TCPBaseSocket::Close()
{
	closesocket(m_Socket);
	m_Socket = INVALID_SOCKET;
}

void TCPBaseSocket::SetSocket(SOCKET Socket)
{
	m_Socket = Socket;
}

bool TCPBaseSocket::IsOk()
{
	return m_Socket != INVALID_SOCKET;
}

SOCKET TCPBaseSocket::GetSocket()
{
	return m_Socket;
}

SOCKADDR_IN TCPBaseSocket::GetAddrIn()
{
	return m_AddrIn;
}

WSADATA TCPBaseSocket::m_WsaData;