/* 
 * Lineage II Extension Project - Affectionately known as the L2EP 'Elhaym' Project/DLL
 * Property of Michael Sadlon a.k.a. mcrabben7 [mcrabben7@gmail.com]
 * Team Effort along with RipperX, Annatar, Nevyn, and with some help from others.
 * 
 * The goals of this project are to expand the aging Lineage II Chronicle 1 server
 * to support the functionality in C3 and C4, and is made to work with the C4 client.
 * 
 * This project is open-source.  It is released from time to time by our discretion.
 * Anyone who has this code, or this DLL, and chooses to use it or learn from it frees
 * us from ALL liabilities.  USE AT YOUR OWN RISK.
 * 
 * I have chosen to release this (you can read the license in License.txt) with the caveat
 * that you may NOT sell our work, any derivative of our work, or make a profit in any way
 * related to our work or a derivative of our work WITHOUT OUR EXPRESS PERMISSION.
 * 
 * Please see License.txt for the full details.  Make sure you READ it!
 */

//General includes
#ifndef _SHARED_
	#include "Shared.h"
#endif

//Project includes
#ifndef _L2SERVER_
	#include "L2Server.h"
#endif
#ifndef _EX_USER_
	#include "ExUser.h"
#endif
#ifndef _AUTOSS_
	#include "AutoSS.h"
#endif

#ifndef _USER_COMMAND_
	#define _USER_COMMAND_
#endif

using namespace std;
using namespace User;

//--------------------------------------------------------------------------------------------
//// Global Variables
//--------------------------------------------------------------------------------------------
//#define DELIMITERS    " \r\n\t!@#$%^&*()_+-={}|\\:\"'??/.,<>??"
#define DELIMITERS  " .,"

//--------------------------------------------------------------------------------------------
//// Function Prototypes
//--------------------------------------------------------------------------------------------

// Handler for the RequestUserCommand Packet (0xAA)
//
// Parameters:
// DWORD * pSocket - address of the socket ID for the client
// DWORD dwCommand - the command requested by the client
//
// Thanks Torune for the original code
//
void UserCommand(DWORD * pSocket, DWORD dwCommand);

// Enables the /loc command in-game
//
// Parameters:
// DWORD * pSocket - address of the Socket ID for the client
//
// Thanks Torune for the original code
//
void ShowLocPacket(DWORD * pSocket);
void ShowNPCLocPacket(DWORD * pSocket, PTCharBaseData CSharedDat2, BYTE showCoords);


// Enables the /time command in-game
//
// Parameters:
// DWORD * pSocket - address of the Socket ID for the client
//
// Thanks Torune for the original code
//
void ShowTimePacket(DWORD * pSocket);

//
void ShowEnterWorldMessageMAIN(DWORD * pSocket);
void ShowEnterWorldMessageC2(DWORD * pSocket);
void ShowEnterWorldMessage_C3(DWORD * pSocket);
void ShowEnterWorldMessageC4(DWORD * pSocket);
void ShowEnterWorldMessageC5(DWORD * pSocket);
void ShowEnterWorldMessageC6(DWORD * pSocket);
void ShowEnterWorldMessageKamael(DWORD * pSocket);
void ShowEnterWorldMessageCT2F(DWORD * pSocket);
void ShowEnterWorldMessageCT2P(DWORD * pSocket);
void ShowEnterWorldMessageCT2Freya(DWORD * pSocket);
void ShowEnterWorldMessageH5(DWORD * pSocket);
void ShowEnterWorldMessageAwakening(DWORD * pSocket);
void ShowEnterWorldMessageLindvior(DWORD * pSocket);


// Enables the /partyinfo command in-game
//
// Parameters:
// DWORD * pSocket - address of the Socket ID for the client
//
// Thanks Torune for the original code
//
void ShowPartyInfoPacket(DWORD * pSocket);

//loot
int loot_the_body(DWORD *pSocket,DWORD *pUserMe, DWORD targetID, BYTE chronicle);
void request_loot(DWORD *pSocket,DWORD *pUser, DWORD item_id,DWORD item_oid, BYTE chronicle);
void RequestEvaluate(DWORD * pSocket, DWORD targetID);

//void RequestBlock(WCHAR *wszMemberName, DWORD blocktype, DWORD *pSocket, DWORD *pUser, ExUser *tempExUser);


bool RequestRide(DWORD *pUser, PTCharBaseData CSharedDat);

double Distance(DWORD * pUser,double x1, double y1, double z1);
int CheckIPAddr2(DWORD * pSocket);
int CheckIPAddr1(DWORD * pSocket);

bool RequestMultisell(DWORD *pUser, PTCharBaseData CSharedDat, int miltisellID);
static const int _multisellDB[54][3]= {
{841,12077,1},
{9841,12077,1},
{851,12077,1},
{9851,12077,1},

{842,12077,2},
{9842,12077,2},
{852,12077,2},
{9852,12077,2},

{843,12077,3},
{9843,12077,3},
{853,12077,3},
{9853,12077,3},
{863,12077,3},
{9863,12077,3},

{844,12077,4},
{9844,12077,4},
{854,12077,4},
{9854,12077,4},
{864,12077,4},
{9864,12077,4},
{874,12077,4},
{9874,12077,4},
{884,12077,4},
{9884,12077,4},
{894,12077,4},
{9894,12077,4},

{845,12077,5},
{9845,12077,5},
{855,12077,5},
{9855,12077,5},
{865,12077,5},
{9865,12077,5},
{875,12077,5},
{9875,12077,5},
{885,12077,5},
{9885,12077,5},

{846,12077,6},
{9846,12077,6},
{856,12077,6},
{9856,12077,6},

{847,12077,7},
{9847,12077,7},
{857,12077,7},
{9857,12077,7},
{867,12077,7},
{9867,12077,7},

{848,12077,8},
{9848,12077,8},
{858,12077,8},
{9858,12077,8},

{849,12077,9},
{9849,12077,9},
{859,12077,9},
{9859,12077,9}
};


	

static const int _recipeDBsize=922; //531;
void RequestRecipeBook(DWORD *pSocket, DWORD *pUser, PTCharBaseData CSharedDat,short isdwarf, BYTE chronicle);

//void RequestRecipeBook_c1(DWORD *pSocket, DWORD *pUser, PTCharBaseData CSharedDat,short isdwarf);
static const int _recipeDB_c1size=689; //495; 
static const int _recipeDB_c1[689][2]= {
{1, 1666},
{2, 1786},
{3, 1787},
{4, 1788},
{5, 1789},
{6, 1790},
{7, 1791},
{8, 1792},
{9, 1793},
{10, 1794},
{11, 1795},
{12, 1796},
{13, 1797},
{14, 1798},
{15, 1799},
{16, 1800},
{17, 1801},
{18, 1802},
{19, 1803},
{20, 1804},
{21, 1805},
{22, 1806},
{23, 1807},
{24, 1808},
{25, 1684},
{26, 1685},
{27, 1686},
{28, 1687},
{29, 1688},
{30, 1814},
{31, 1690},
{32, 1691},
{33, 1817},
{34, 1693},
{35, 1694},
{36, 1695},
{37, 1696},
{38, 1697},
{39, 1698},
{40, 1699},
{41, 1825},
{42, 1701},
{43, 1702},
{44, 1703},
{45, 2135},
{46, 2136},
{47, 2137},
{48, 2138},
{49, 2139},
{50, 2140},
{51, 2141},
{52, 2142},
{53, 2143},
{54, 2144},
{55, 2145},
{56, 2146},
{57, 2147},
{58, 2148},
{59, 2149},
{60, 2150},
{61, 2151},
{62, 2152},
{63, 2153},
{64, 2154},
{65, 2155},
{66, 2156},
{67, 2157},
{68, 2158},
{69, 2159},
{70, 2160},
{71, 2161},
{72, 2162},
{73, 2163},
{74, 2164},
{75, 2165},
{76, 2166},
{77, 2167},
{78, 2168},
{79, 2169},
{80, 2170},
{81, 2171},
{82, 2172},
{83, 2173},
{84, 2174},
{85, 2175},
{86, 2176},
{87, 2177},
{88, 2178},
{89, 2179},
{90, 2180},
{91, 2181},
{92, 2182},
{93, 2183},
{94, 2184},
{95, 2185},
{96, 2186},
{97, 2187},
{98, 2188},
{99, 2189},
{100, 2190},
{101, 2191},
{102, 2192},
{103, 2193},
{104, 2194},
{105, 2195},
{106, 2196},
{107, 2197},
{108, 2198},
{109, 2199},
{110, 2200},
{111, 2201},
{112, 2202},
{113, 2203},
{114, 2204},
{115, 2205},
{116, 2206},
{117, 2207},
{118, 2208},
{119, 2209},
{120, 2210},
{121, 2211},
{122, 2212},
{123, 2213},
{124, 2214},
{125, 2215},
{126, 2216},
{127, 2217},
{128, 2218},
{129, 2219},
{130, 2220},
{131, 2221},
{132, 2222},
{133, 2223},
{134, 2224},
{135, 2225},
{136, 2226},
{137, 2227},
{138, 2228},
{139, 2229},
{140, 2230},
{141, 2231},
{142, 2232},
{143, 2233},
{144, 2234},
{145, 2235},
{146, 2236},
{147, 2237},
{148, 2238},
{149, 2239},
{150, 2240},
{151, 2241},
{152, 2242},
{153, 2243},
{154, 2244},
{155, 2245},
{156, 2246},
{157, 2247},
{158, 2248},
{159, 2249},
{160, 2250},
{161, 2251},
{162, 2252},
{163, 2253},
{164, 2254},
{165, 2255},
{166, 2256},
{167, 2257},
{168, 2258},
{169, 2259},
{170, 2260},
{171, 2261},
{172, 2262},
{173, 2263},
{174, 2264},
{175, 2265},
{176, 2266},
{177, 2267},
{178, 2268},
{179, 2269},
{180, 2270},
{181, 2271},
{182, 2272},
{183, 2273},
{184, 2274},
{185, 2275},
{186, 2276},
{187, 2277},
{188, 2278},
{189, 2279},
{190, 2280},
{191, 2281},
{192, 2282},
{193, 2283},
{194, 2284},
{195, 2285},
{196, 2286},
{197, 2287},
{198, 2288},
{199, 2289},
{200, 2290},
{201, 2291},
{202, 2292},
{203, 2293},
{204, 2294},
{205, 2295},
{206, 2296},
{207, 2297},
{208, 2298},
{209, 2299},
{210, 2300},
{211, 2301},
{212, 2302},
{213, 2303},
{214, 2304},
{215, 2305},
{216, 2306},
{217, 2307},
{218, 2308},
{219, 2309},
{220, 2310},
{221, 2311},
{222, 2312},
{223, 2313},
{224, 2314},
{225, 2315},
{226, 2316},
{227, 2317},
{228, 2318},
{229, 2319},
{230, 2320},
{231, 2321},
{232, 2322},
{233, 2323},
{234, 2324},
{235, 2325},
{236, 2326},
{237, 2327},
{238, 2328},
{239, 2329},
{240, 2330},
{241, 2331},
{242, 2332},
{243, 2333},
{244, 2334},
{245, 2335},
{246, 2336},
{247, 2337},
{248, 2338},
{249, 2339},
{250, 2340},
{251, 2341},
{252, 2342},
{253, 2343},
{254, 2344},
{255, 2345},
{256, 2346},
{257, 2347},
{258, 2348},
{259, 2349},
{260, 2350},
{261, 2351},
{262, 2352},
{263, 2353},
{264, 2354},
{265, 2355},
{266, 2356},
{267, 2357},
{268, 2358},
{269, 2359},
{270, 2360},
{271, 2361},
{272, 2362},
{273, 2363},
{274, 2364},
{275, 2365},
{276, 2366},
{277, 2367},
{278, 2970},
{279, 2971},
{280, 2972},
{281, 2973},
{282, 2974},
{283, 2975},
{284, 2976},
{285, 2977},
{286, 2978},
{287, 2979},
{288, 2980},
{289, 2981},
{290, 2982},
{291, 2983},
{292, 2984},
{293, 2985},
{294, 2986},
{295, 2987},
{296, 2988},
{297, 2989},
{298, 2990},
{299, 2991},
{300, 2992},
{301, 2993},
{302, 2994},
{303, 2995},
{304, 2996},
{305, 2997},
{306, 2998},
{307, 2999},
{308, 3000},
{309, 3001},
{310, 3002},
{311, 3003},
{312, 3004},
{313, 3005},
{314, 3006},
{315, 3007},
{316, 3008},
{317, 3009},
{318, 3010},
{319, 3011},
{320, 3012},
{321, 3013},
{322, 3014},
{323, 3015},
{324, 3016},
{325, 3017},
{326, 3018},
{327, 3019},
{328, 3020},
{329, 3021},
{330, 3022},
{331, 3023},
{332, 3024},
{333, 3025},
{334, 3032},
{335, 3033},
{336, 3034},
{337, 3035},
{338, 3036},
{339, 3838},
{340, 3953},
{341, 3954},
{342, 3955},
{343, 3956},
{344, 3957},
{345, 4126},
{346, 4126},
{347, 4127},
{348, 4127},
{349, 4128},
{350, 4128},
{351, 4129},
{352, 4129},
{353, 4130},
{354, 4130},
{355, 4131},
{356, 4131},
{357, 4132},
{358, 4133},
{359, 4133},
{360, 4134},
{361, 4134},
{362, 4135},
{363, 4135},
{364, 4136},
{365, 4136},
{366, 4137},
{367, 4137},
{368, 4138},
{369, 4138},
{370, 4139},
{371, 4139},
{372, 4140},
{373, 4140},
{374, 4141},
{375, 4141},
{376, 4142},
{377, 4142},
{378, 4143},
{379, 4143},
{380, 4144},
{381, 4144},
{382, 4145},
{383, 4145},
{384, 4146},
{385, 4146},
{386, 4147},
{387, 4147},
{388, 4148},
{389, 4148},
{390, 4149},
{391, 4149},
{392, 4150},
{393, 4150},
{394, 4151},
{395, 4151},
{396, 4152},
{397, 4152},
{398, 4153},
{399, 4153},
{400, 4154},
{401, 4154},
{402, 4155},
{403, 4155},
{404, 4156},
{405, 4156},
{406, 4157},
{407, 4157},
{408, 4158},
{409, 4158},
{410, 4159},
{411, 4159},
{412, 4160},
{413, 4160},
{414, 4161},
{415, 4161},
{416, 4162},
{417, 4162},
{418, 4163},
{419, 4163},
{420, 4164},
{421, 4164},
{422, 4165},
{423, 4165},
{424, 4166},
{425, 4166},
{426, 4167},
{427, 4167},
{428, 4168},
{429, 4168},
{430, 4169},
{431, 4169},
{432, 4170},
{433, 4170},
{434, 4171},
{435, 4171},
{436, 4172},
{437, 4172},
{438, 4173},
{439, 4173},
{440, 4174},
{441, 4174},
{442, 4175},
{443, 4175},
{444, 4176},
{445, 4176},
{446, 4177},
{447, 4177},
{448, 4178},
{449, 4178},
{450, 4179},
{451, 4179},
{452, 4180},
{453, 4181},
{454, 4181},
{455, 4182},
{456, 4182},
{457, 4183},
{458, 4183},
{459, 4184},
{460, 4184},
{461, 4185},
{462, 4185},
{463, 4186},
{464, 4186},
{465, 4187},
{466, 4187},
{467, 4188},
{468, 4188},
{469, 4189},
{470, 4189},
{471, 4190},
{472, 4190},
{473, 4191},
{474, 4191},
{475, 4192},
{476, 4192},
{477, 4193},
{478, 4193},
{479, 4194},
{480, 4194},
{481, 4195},
{482, 4195},
{483, 4196},
{484, 4196},
{485, 4197},
{486, 4197},
{487, 4198},
{488, 4198},
{489, 4199},
{490, 4199},
{491, 4122},
{492, 4123},
{493, 4124},
{494, 4125},

{495, 4440},
{496, 5230},
{503, 5436},
{504, 5437},
{505, 6901},


{513,5332},
{514,5333},
{515,5334},
{516,5335},
{517,5336},
{518,5337},
{519,5338},
{520,5339},
{521,5340},
{522,5341},

{523,5346},
{524,5347},
{525,5348},
{526,5349},
{527,5350},
{528,5351},
{529,5352},
{530,5353},
{531,5354},
{532,5355},

{533,5364},
{534,5365},
{535,5366},
{536,5367},
{537,5368},
{538,5369},
{539,5370},
{540,5371},
{541,5380},
{542,5381},

{543,5382},
{544,5383},
{545,5392},
{546,5393},
{547,5394},
{548,5395},
{549,5404},
{550,5405},
{551,5406},
{552,5407},

{553,5416},
{554,5417},
{555,5418},
{556,5419},
{557,5420},
{558,5421},
{559,5422},
{560,5423},
{561,5424},
{562,5425},

{563,5426},
{564,5427},
{565,5428},
{566,5429},
{567,5430},
{568,5431},
{569,5432},
{570,5433},
{571,5434},
{572,5435},

{573,5436},
{574,5437},
{575,5438},
{576,5439},
{577,5440},
{578,5441},
{579,5442},
{580,5443},
{581,5444},
{582,5445},

{583,5446},
{584,5447},
{585,5448},
{586,5449},
{587,5450},
{588,5451},
{589,5452},
{590,5453},
{591,5456},
{592,5457},

{593,5458},
{594,5459},
{595,5460},
{596,5461},
{597,5462},
{598,5463},
{599,5464},
{600,5465},
{601,5466},
{602,5467},

{603,5468},
{604,5469},
{605,5470},
{606,5471},
{607,5472},
{608,5473},
{609,5474},
{610,5475},
{611,5476},
{612,5477},

{613,6331},
{614,6332},
{615,6337},
{616,6338},
{617,6329},
{618,6330},
{619,6335},
{620,6336},
{621,6333},
{622,6334},

{623,6339},
{624,6340},

//recipe book shots 12
{625,8547}, //ssd
{626,8547}, //ssc
{627,8547}, //ssb
{628,8547}, //spiritshot d
{629,8547},
{630,8547},
{632,8547}, //bssd
{632,8547}, //bssc
{633,8547}, //bssb
{634,8547}, //arrow d
{635,8547}, //arrow c
{636,8547}, //arrow b


//recipe book mats 22
{637,8548},
{638,8548},
{639,8548},
{640,8548},
{641,8548},
{642,8548},
{643,8548},
{644,8548},
{645,8548},
{646,8548},
{647,8548},
{648,8548},
{649,8548},
{650,8548},
{651,8548},
{652,8548},
{653,8548},
{654,8548},
{655,8548},
{656,8548},
{657,8548},
{658,8548},

//recipe book shots 21
{2020,8547},
{2021,8547},
{2022,8547},
{2023,8549},
{2024,8549},
{2034,8547},
{2035,8547},
{2036,8547},
{2037,8549},
{2038,8549},
{2340,8547},
{2341,8547},
{2342,8547},
{2343,8549},
{2344,8549},
{2001,8547},
{2160,8547},
{2161,8547},
{2452,8547},
{2496,8549},
{2625,8549},

//recipe book mats 22
{2030,8548},
{2033,8548},
{2041,8548},
{2045,8548},
{2046,8548},
{2047,8548},
{2048,8548},
{2049,8548},
{2050,8548},
{2051,8548},
{2052,8548},
{2053,8548},
{2054,8548},
{2055,8548},
{2056,8548},
{2057,8548},
{2058,8548},
{2059,8548},
{2491,8548},
{2492,8548},
{2493,8548},
{2494,8548},


{0,0}
};


//c4 recipe db for display in C2 recipe book dialog
static const int _recipeDB[922][2]= {

{1,1666},
{2,1786},
{3,1787},
{4,1788},
{5,1789},
{6,1790},
{7,1791},
{8,1792},
{9,1793},
{10,1794},
{11,1795},
{12,1796},
{13,1797},
{14,1798},
{15,1799},
{16,1800},
{17,1801},
{18,1802},
{19,1803},
{20,1804},
{21,1805},
{22,1806},
{23,1807},
{24,1808},
{25,1814},
{26,1817},
{27,1825},
{28,2135},
{29,2136},
{30,2137},
{31,2138},
{32,2139},
{33,2140},
{34,2141},
{35,2142},
{36,2143},
{37,2144},
{38,2145},
{39,2146},
{40,2147},
{41,2148},
{42,2149},
{43,2150},
{44,2151},
{45,2152},
{46,2153},
{47,2154},
{48,2155},
{49,2156},
{50,2157},
{51,2158},
{52,2159},
{53,2160},
{54,2161},
{55,2162},
{56,2163},
{57,2164},
{58,2165},
{59,2166},
{60,2167},
{61,2168},
{62,2169},
{63,2170},
{64,2171},
{65,2172},
{66,2173},
{67,2174},
{68,2175},
{69,2176},
{70,2177},
{71,2178},
{72,2179},
{73,2180},
{74,2181},
{75,2182},
{76,2183},
{77,2184},
{78,2185},
{79,2186},
{80,2187},
{81,2188},
{82,2189},
{83,2190},
{84,2191},
{85,2192},
{86,2193},
{87,2194},
{88,2195},
{89,2196},
{90,2197},
{91,2198},
{92,2199},
{93,2200},
{94,2201},
{95,2202},
{96,2203},
{97,2204},
{98,2205},
{99,2206},
{100,2207},
{101,2208},
{102,2209},
{103,2210},
{104,2211},
{105,2212},
{106,2213},
{107,2214},
{108,2215},
{109,2216},
{110,2217},
{111,2218},
{112,2219},
{113,2220},
{114,2221},
{115,2222},
{116,2223},
{117,2224},
{118,2225},
{119,2226},
{120,2227},
{121,2228},
{122,2229},
{123,2230},
{124,2231},
{125,2232},
{126,2233},
{127,2234},
{128,2235},
{129,2236},
{130,2237},
{131,2238},
{132,2239},
{133,2240},
{134,2241},
{135,2242},
{136,2243},
{137,2244},
{138,5008},
{139,2246},
{140,2247},
{141,2248},
{142,2249},
{143,2250},
{144,2251},
{145,2252},
{146,2253},
{147,2254},
{148,2255},
{149,2256},
{150,2257},
{151,2258},
{152,2259},
{153,2260},
{154,2261},
{155,2262},
{156,2263},
{157,2264},
{158,2265},
{159,2266},
{160,2267},
{161,2268},
{162,2269},
{163,2270},
{164,2271},
{165,2272},
{166,2273},
{167,2274},
{168,2275},
{169,2276},
{170,2277},
{171,2278},
{172,2279},
{173,2280},
{174,2281},
{175,2282},
{176,2283},
{177,2284},
{178,2285},
{179,2286},
{180,2287},
{181,2288},
{182,2289},
{183,2290},
{184,2291},
{185,2292},
{186,2293},
{187,2294},
{188,2295},
{189,2296},
{190,2297},
{191,2298},
{192,2299},
{193,2300},
{194,2301},
{195,2302},
{196,2303},
{197,2304},
{198,2305},
{199,2306},
{200,2307},
{201,2308},
{202,2309},
{203,2310},
{204,2311},
{205,2312},
{206,2313},
{207,2314},
{208,2315},
{209,2316},
{210,2317},
{211,2318},
{212,2319},
{213,2320},
{214,2321},
{215,2322},
{216,2323},
{217,2324},
{218,2325},
{219,2326},
{220,2327},
{221,2328},
{222,2329},
{223,2330},
{224,2331},
{225,2332},
{226,2333},
{227,2334},
{228,2335},
{229,2336},
{230,2337},
{231,2338},
{232,2339},
{233,2340},
{234,2341},
{235,2342},
{236,2343},
{237,2344},
{238,2345},
{239,2346},
{240,2347},
{241,2348},
{242,2349},
{243,2350},
{244,2351},
{245,2352},
{246,2353},
{247,2354},
{248,2355},
{249,2356},
{250,2357},
{251,2358},
{252,2359},
{253,2360},
{254,2361},
{255,2362},
{256,2363},
{257,2364},
{258,2365},
{259,2366},
{260,2367},
{261,2970},
{262,2971},
{263,2972},
{264,2973},
{265,2974},
{266,2975},
{267,2976},
{268,2977},
{269,2978},
{270,2979},
{271,2980},
{272,2981},
{273,2982},
{274,2983},
{275,2984},
{276,2985},
{277,2986},
{278,2987},
{279,2988},
{280,2989},
{281,2990},
{282,2991},
{283,2992},
{284,2993},
{285,2994},
{286,2995},
{287,2996},
{288,2997},
{289,2998},
{290,2999},
{291,3000},
{292,3001},
{293,3002},
{294,3003},
{295,3004},
{296,3005},
{297,3006},
{298,3007},
{299,3008},
{300,3009},
{301,3010},
{302,3011},
{303,3012},
{304,3013},
{305,3014},
{306,3015},
{307,3016},
{308,3017},
{309,3018},
{310,3019},
{311,3020},
{312,3021},
{313,3022},
{314,3023},
{315,3024},
{316,3025},
{317,3032},
{318,3033},
{319,3034},
{320,3035},
{321,3036},
{322,3838},
{323,3953},
{324,3954},
{325,3955},
{326,3956},
{327,3957},
{328,4937},
{329,4126},
{330,4938},
{331,4127},
{332,4939},
{333,4128},
{334,4973},
{335,4129},
{336,4974},
{337,4130},
{338,4975},
{339,4131},
{340,4132},
{341,4940},
{342,4133},
{343,4941},
{344,4134},
{345,4976},
{346,4135},
{347,4942},
{348,4136},
{349,4943},
{350,4137},
{351,4977},
{352,4138},
{353,4978},
{354,4139},
{355,4979},
{356,4140},
{357,4944},
{358,4141},
{359,4945},
{360,4142},
{361,4946},
{362,4143},
{363,4947},
{364,4144},
{365,4948},
{366,4145},
{367,4949},
{368,4146},
{369,4950},
{370,4147},
{371,4951},
{372,4148},
{373,4952},
{374,4149},
{375,4953},
{376,4150},
{377,4954},
{378,4151},
{379,4955},
{380,4152},
{381,4956},
{382,4153},
{383,4980},
{384,4154},
{385,4981},
{386,4155},
{387,4957},
{388,4156},
{389,4982},
{390,4157},
{391,4983},
{392,4158},
{393,4984},
{394,4159},
{395,4985},
{396,4160},
{397,4986},
{398,4161},
{399,4987},
{400,4162},
{401,4988},
{402,4163},
{403,4989},
{404,4164},
{405,4990},
{406,4165},
{407,4991},
{408,4166},
{409,4992},
{410,4167},
{411,4993},
{412,4168},
{413,4994},
{414,4169},
{415,4995},
{416,4170},
{417,4996},
{418,4171},
{419,4997},
{420,4172},
{421,4998},
{422,4173},
{423,4958},
{424,4174},
{425,4959},
{426,4175},
{427,4999},
{428,4176},
{429,4960},
{430,4177},
{431,4961},
{432,4178},
{433,4962},
{434,4179},
{435,4180},
{436,5008},
{437,4181},
{438,4963},
{439,4182},
{440,4964},
{441,4183},
{442,4965},
{443,4184},
{444,4966},
{445,4185},
{446,4967},
{447,4186},
{448,4968},
{449,4187},
{450,4969},
{451,4188},
{452,4970},
{453,4189},
{454,4971},
{455,4190},
{456,4972},
{457,4191},
{458,5000},
{459,4192},
{460,5001},
{461,4193},
{462,5002},
{463,4194},
{464,5003},
{465,4195},
{466,5004},
{467,4196},
{468,5005},
{469,4197},
{470,5006},
{471,4198},
{472,5007},
{473,4199},
{474,4122},
{475,4123},
{476,4124},
{477,4125},
{478,4936},
{479,4441},
{480,5153},
{481,5154},
{482,5155},
{483,5156},
{484,5157},
{485,5158},
{486,5159},
{487,5160},
{488,5161},
{489,5162},
{490,5163},
{491,5164},
{492,5165},
{493,5166},
{494,5167},
{495,4440},
{496,5230},
{497,5231},
{498,5268},
{499,5269},
{500,5270},
{501,5271},
{502,5272},
{503,5273},
{504,5274},
{505,5275},
{506,5276},
{507,5277},
{508,5278},
{509,5279},
{510,5280},
{511,5281},
{512,5282},
{513,5332},
{514,5333},
{515,5334},
{516,5335},
{517,5336},
{518,5337},
{519,5338},
{520,5339},
{521,5340},
{522,5341},
{523,5346},
{524,5347},
{525,5348},
{526,5349},
{527,5350},
{528,5351},
{529,5352},
{530,5353},
{531,5354},
{532,5355},
{533,5364},
{534,5365},
{535,5366},
{536,5367},
{537,5368},
{538,5369},
{539,5370},
{540,5371},
{541,5380},
{542,5381},
{543,5382},
{544,5383},
{545,5392},
{546,5393},
{547,5394},
{548,5395},
{549,5404},
{550,5405},
{551,5406},
{552,5407},
{553,5416},
{554,5417},
{555,5418},
{556,5419},
{557,5420},
{558,5421},
{559,5422},
{560,5423},
{561,5424},
{562,5425},
{563,5426},
{564,5427},
{565,5428},
{566,5429},
{567,5430},
{568,5431},
{569,5432},
{570,5433},
{571,5434},
{572,5435},
{573,5436},
{574,5437},
{575,5438},
{576,5439},
{577,5440},
{578,5441},
{579,5442},
{580,5443},
{581,5444},
{582,5445},
{583,5446},
{584,5447},
{585,5448},
{586,5449},
{587,5450},
{588,5451},
{589,5452},
{590,5453},
{591,5456},
{592,5457},
{593,5458},
{594,5459},
{595,5460},
{596,5461},
{597,5462},
{598,5463},
{599,5464},
{600,5465},
{601,5466},
{602,5467},
{603,5468},
{604,5469},
{605,5470},
{606,5471},
{607,5472},
{608,5473},
{609,5474},
{610,5475},
{611,5476},
{612,5477},
{613,6331},
{614,6332},
{615,6337},
{616,6338},
{617,6329},
{618,6330},
{619,6335},
{620,6336},
{621,6333},
{622,6334},
{623,6339},
{624,6340},
{625,6901},
{626,6881},
{627,6882},
{628,6883},
{629,6884},
{630,6885},
{631,6886},
{632,6887},
{633,6888},
{634,6889},
{635,6890},
{636,6891},
{637,6892},
{638,6893},
{639,6894},
{640,6895},
{641,6896},
{642,6897},
{643,6898},
{644,6899},
{645,6900},
{646,6847},
{647,6848},
{648,6849},
{649,6850},
{650,6851},
{651,6852},
{652,6853},
{653,6854},
{654,6855},
{655,6856},
{656,6857},
{657,6858},
{658,6859},
{659,6860},
{660,6861},
{661,6862},
{662,6863},
{663,6864},
{664,6865},
{665,6866},
{666,6867},
{667,6868},
{668,6869},
{669,6870},
{670,6871},
{671,6872},
{672,6873},
{673,6874},
{674,6875},
{675,6876},
{676,6877},
{677,6878},
{678,6879},
{679,6880},
{680,6920},
{681,6921},
{682,6922},
{683,6923},
{684,6924},
{685,6925},
{686,6926},
{687,6927},
{688,6928},
{689,6929},
{690,6930},
{691,6931},
{692,6932},
{693,6933},
{694,6934},
{695,6935},
{696,6936},
{697,6937},
{698,6938},
{699,6939},
{700,6940},
{701,6941},
{702,6942},
{703,6943},
{704,6944},
{705,6945},
{706,6946},
{707,6947},
{708,6948},
{709,6949},
{710,6950},
{711,6951},
{712,6952},
{713,6953},
{714,6954},
{715,6955},
{716,6956},
{717,6957},
{718,6958},
{719,6959},
{720,6960},
{721,6961},
{722,6962},
{723,6963},
{724,6964},
{725,6965},
{726,6966},
{727,6967},
{728,6968},
{729,6969},
{730,6970},
{731,6971},
{732,6972},
{733,6973},
{734,6974},
{735,6975},
{736,6976},
{737,6977},
{738,6978},
{739,6979},
{740,6980},
{741,6981},
{742,6982},
{743,6983},
{744,6984},
{745,6985},
{746,6986},
{747,6987},
{748,6988},
{749,6989},
{750,6990},
{751,6991},
{752,6992},
{753,6993},
{754,6994},
{755,6995},
{756,6996},
{757,6997},
{758,6998},
{759,6999},
{760,7000},
{761,7001},
{762,7002},
{763,7003},
{764,7004},
{765,7005},
{766,7006},
{767,7007},
{768,7008},
{769,7009},
{770,7010},
{771,7011},
{772,7012},
{773,7013},
{774,7580},
{775,7581},
{776,7689},
{777,7690},
{778,7691},
{779,7692},
{780,7693},
{781,7699},
{782,7700},
{783,8294},
{784,8301},
{785,8295},
{786,8302},
{787,8307},
{788,8317},
{789,8296},
{790,8319},
{791,8303},
{792,8304},
{793,8308},
{794,8310},
{795,8309},
{796,8322},
{797,8321},
{798,8306},
{799,8305},
{800,8312},
{801,8311},
{802,8324},
{803,8323},
{804,8314},
{805,8313},
{806,8316},
{807,8315},
{808,8326},
{809,8325},
{810,8298},
{811,8297},
{812,8487},
{813,8320},
{814,8300},
{815,8299},
{816,8318},
{817,8370},
{818,8371},
{819,8372},
{820,8365},
{821,8364},
{822,8367},
{823,8366},
{824,8369},
{825,8368},
{844,8690},
{845,8691},
{846,8692},
{847,8693},
{848,8694},
{849,8695},
{850,8696},
{851,8697},
{852,8698},
{853,8699},
{854,8700},
{855,8701},
{856,8702},
{857,8703},
{858,8704},
{859,8705},
{860,8706},
{861,8707},
{862,8708},
{863,8709},
{864,8710},
{865,8711},
{872,9967},
{873,9968},
{874,9969},
{875,9970},
{876,9971},
{877,9972},
{878,9973},
{879,9974},
{880,9975},
{881,9482},
{882,9483},
{883,9484},
{884,9485},
{885,9486},
{886,9487},
{887,9488},
{888,9489},
{889,9490},
{890,9491},
{891,9492},
{892,9493},
{893,9494},
{894,9495},
{895,9496},
{896,9497},
{897,9985},
{898,9986},
{899,9987},
{901,1693},
{902,1694},
{903,1695},
{904,1696},
{905,1697},
{906,1698},
{907,1699},
{908,1690},
{909,1691},
{826,1826},
{827,1827},
{828,1828},
{901,4973},
{902,4973},
{903,4973},
{904,4973},
{905,4973},
{906,4973},
{907,4973},
{908,4973},
{909,4973},
{910,4973},
{931,4973},
{911,4974},
{912,4974},
{913,4974},
{914,4974},
{915,4974},
{916,4974},
{917,4974},
{918,4974},
{919,4974},
{920,4974},
{932,4974},
{921,4975},
{922,4975},
{923,4975},
{924,4975},
{925,4975},
{926,4975},
{927,4975},
{928,4975},
{929,4975},
{930,4975},
{933,4975},
{934,4936},
{0,0}
};


static const int _LOC_MSG[18] = {
		910,
		914,
		915,
		920,
		921,
		912,
		911,
		916,
		918,
		922,
		924,
		923,
		919,
		926,
		1537,
		1538,

		1924,
		913
	};
/*
	int _LOC_MSG_[21] = {

910, //	1	Current location : $s1, $s2, $s3 (Near Talking Island Village)	0	79	9B	B0	FF			0	0	0	0	0		none
911, //	1	Current location : $s1, $s2, $s3 (Near Gludin Village)	0	79	9B	B0	FF			0	0	0	0	0		none
912, //	1	Current location : $s1, $s2, $s3 (Near the Town of Gludio)	0	79	9B	B0	FF			0	0	0	0	0		none
913, //	1	Current location : $s1, $s2, $s3 (Near the Neutral Zone)	0	79	9B	B0	FF			0	0	0	0	0		none
914, //	1	Current location : $s1, $s2, $s3 (Near the Elven Village)	0	79	9B	B0	FF			0	0	0	0	0		none
915, //	1	Current location : $s1, $s2, $s3 (Near the Dark Elf Village)	0	79	9B	B0	FF			0	0	0	0	0		none
916, //	1	Current location : $s1, $s2, $s3 (Near the Town of Dion)	0	79	9B	B0	FF			0	0	0	0	0		none
917, //	1	Current location : $s1, $s2, $s3 (Near the Floran Village)	0	79	9B	B0	FF			0	0	0	0	0		none
918, //	1	Current location : $s1, $s2, $s3 (Near the Town of Giran)	0	79	9B	B0	FF			0	0	0	0	0		none
919, //	1	Current location : $s1, $s2, $s3 (Near Giran Harbor)	0	79	9B	B0	FF			0	0	0	0	0		none
920, //	1	Current location : $s1, $s2, $s3 (Near the Orc Village)	0	79	9B	B0	FF			0	0	0	0	0		none
921, //	1	Current location : $s1, $s2, $s3 (Near the Dwarven Village)	0	79	9B	B0	FF			0	0	0	0	0		none
922, //	1	Current location : $s1, $s2, $s3 (Near the Town of Oren)	0	79	9B	B0	FF			0	0	0	0	0		none
923, //	1	Current location : $s1, $s2, $s3 (Near Hunters Village)	0	79	9B	B0	FF			0	0	0	0	0		none
924, //	1	Current location : $s1, $s2, $s3 (Near Aden Castle Town)	0	79	9B	B0	FF			0	0	0	0	0		none
925, //	1	Current location : $s1, $s2, $s3 (Near the Coliseum)	0	79	9B	B0	FF			0	0	0	0	0		none
926, //	1	Current location : $s1, $s2, $s3 (Near Heine)	0	79	9B	B0	FF			0	0	0	0	0		none
1537, //1	Current Location:  $s1, $s2, $s3 (near Rune Village)	0	79	9B	B0	FF			0	0	0	0	0		none
1538, //1	Current Location: $s1, $s2, $s3 (near the Town of Goddard)	0	79	9B	B0	FF			0	0	0	0	0		none
1714, //1	a,Current Location: $s1, $s2, $s3 (Near the Town of Schuttgart)\0	0	79	9B	B0	FF	a,	a,	0	0	0	0	0	a,	a,none\0
1924 //	1	a,Current Location: $s1, $s2, $s3 (near the Primeval Isle)\0	0	79	9B	B0	FF	a,	a,	0	0	0	0	0	a,	a,none\0
};
*/

static const int _regions[18][10]=
	{
	   {17,17,17,17,17,17, 4, 4, 4, 4}, //y=9 by ripper
	   {17,17,17,17,17,17, 4, 4, 4, 4}, //10
	   {17,17,17,17,17,17, 4, 4, 4, 4}, //11
	   {17,17,17,17,17,17, 4, 4, 4, 4}, //12
	   {17,17, 3, 3, 3,16,16,16, 4, 4}, //13
	   {17, 3, 3, 3, 3,16,16,16,15,15}, //14
	   {17,17,17, 3, 3,14,14,15,15,15}, //15
	   {17,17,17,14,14,14,14,15,15,15}, //16
	   {17,17,17,14,14,14,14,15,15,15}, //17
	   {17,17,17, 2, 2, 2, 9, 9,10,10}, //18
	   {17,17, 2, 2, 2, 9, 9,10,10,10}, //19
	   {17, 6, 6, 2, 5, 1, 9,11,11,11}, //20
	   {6 , 6, 5, 5, 7, 7, 8, 8, 8, 8}, //21
	   {6 , 6, 6, 5, 7, 7, 8, 8, 8, 8}, //22
	   {6 , 6, 6, 5, 7, 7, 8, 8,13,17}, //23
	   {0 , 0, 6, 6, 7,12,13,13,13,17}, //24
	   {0 , 0,17,17,17, 0,13,13,13,17}, //25
	   {0 , 0,17,17,17,17,13,13,17,17}  //y=26 by smeli
       //x=16 by smeli             x=25
	   //rippers one starts from tile x=17
	};

static const BYTE _item_flood_cnt=23+6;
static const BYTE _item_flood[_item_flood_cnt] =
{
0x11,		//RequestUnequipItem
0x12,		//RequestDropItem
0x13,		//RequestDropItemFromPet
0x14,		//UseItem
0x15,		//Request trade
0x16,		//AddTradeItem
0x17,		//Trade done
0x44,		//Answer Trade
0x1e,		//RequestSellItem
0x1f,		//1F RequestBuyItem
0x2F,		//RequestMagicSkillUse
0x31,		//SendWareHouseDepositList
0x32,		//SendWareHouseWithDrawList
0x72,		//RequestCrystallizeItem
0x74,		//PrivateStoreSell
0x79,		//SendPrivateStoreBuyBuyList
0x8a,		//RequestPetUseItem
0x8b,		//RequestGiveItemToPet
0x8c,		//RequestGetItemFromPet
0x91,		//privatestorebuy
0x96,		//RequestPrivateStoreSell
0x9f,		//request package send
0xa7,		//request multisell choose

0x58, //request enchant item
0x6C, //request Aquire skill
0x0A, //Request Attack
0x2F, //request magic skill use
0xAA, //request user command
0x04  //request action


};


static const int _questitems_cnt=1990;
static const int _questitems[_questitems_cnt] = {
687 ,
688 ,
689 ,
690 ,
691 ,
692 ,
693 ,
694 ,
695 ,
696 ,
697 ,
698 ,
699 ,
700 ,
701 ,
702 ,
703 ,
704 ,
705 ,
706 ,
707 ,
708 ,
709 ,
710 ,
711 ,
712 ,
713 ,
714 ,
715 ,
716 ,
717 ,
718 ,
719 ,
720 ,
721 ,
722 ,
723 ,
724 ,
739 ,
740 ,
741 ,
742 ,
745 ,
746 ,
750 ,
751 ,
752 ,
753 ,
755 ,
756 ,
757 ,
758 ,
759 ,
760 ,
761 ,
762 ,
763 ,
764 ,
765 ,
766 ,
767 ,
768 ,
769 ,
770 ,
771 ,
772 ,
773 ,
774 ,
775 ,
776 ,
777 ,
778 ,
779 ,
780 ,
781 ,
782 ,
783 ,
784 ,
785 ,
786 ,
787 ,
788 ,
789 ,
790 ,
791 ,
792 ,
793 ,
794 ,
795 ,
796 ,
797 ,
798 ,
799 ,
800 ,
801 ,
802 ,
803 ,
804 ,
805 ,
806 ,
807 ,
808 ,
809 ,
810 ,
811 ,
812 ,
813 ,
814 ,
815 ,
816 ,
817 ,
818 ,
819 ,
820 ,
821 ,
822 ,
823 ,
824 ,
825 ,
826 ,
827 ,
828 ,
829 ,
830 ,
831 ,
832 ,
833 ,
834 ,
835 ,
836 ,
837 ,
838 ,
839 ,
840 ,
841 ,
842 ,
844 ,
937 ,
939 ,
940 ,
941 ,
942 ,
943 ,
944 ,
963 ,
964 ,
965 ,
966 ,
967 ,
968 ,
969 ,
970 ,
971 ,
972 ,
973 ,
974 ,
976 ,
977 ,
978 ,
979 ,
980 ,
982 ,
983 ,
984 ,
985 ,
986 ,
987 ,
988 ,
998 ,
999 ,
1000 ,
1001 ,
1002 ,
1003 ,
1004 ,
1005 ,
1006 ,
1007 ,
1008 ,
1009 ,
1010 ,
1011 ,
1012 ,
1013 ,
1014 ,
1015 ,
1016 ,
1017 ,
1018 ,
1019 ,
1020 ,
1021 ,
1022 ,
1023 ,
1024 ,
1025 ,
1026 ,
1027 ,
1028 ,
1029 ,
1030 ,
1031 ,
1032 ,
1033 ,
1034 ,
1035 ,
1036 ,
1037 ,
1038 ,
1039 ,
1040 ,
1041 ,
1042 ,
1043 ,
1044 ,
1045 ,
1046 ,
1063 ,
1064 ,
1065 ,
1066 ,
1067 ,
1068 ,
1069 ,
1070 ,
1071 ,
1072 ,
1076 ,
1077 ,
1078 ,
1079 ,
1080 ,
1081 ,
1082 ,
1083 ,
1084 ,
1085 ,
1086 ,
1087 ,
1088 ,
1089 ,
1090 ,
1091 ,
1092 ,
1093 ,
1094 ,
1106 ,
1107 ,
1108 ,
1109 ,
1110 ,
1111 ,
1112 ,
1113 ,
1114 ,
1115 ,
1116 ,
1117 ,
1118 ,
1130 ,
1131 ,
1132 ,
1133 ,
1134 ,
1135 ,
1136 ,
1137 ,
1138 ,
1139 ,
1140 ,
1141 ,
1143 ,
1144 ,
1145 ,
1153 ,
1154 ,
1155 ,
1156 ,
1157 ,
1158 ,
1159 ,
1160 ,
1161 ,
1162 ,
1163 ,
1164 ,
1165 ,
1166 ,
1167 ,
1168 ,
1169 ,
1170 ,
1171 ,
1172 ,
1173 ,
1174 ,
1175 ,
1176 ,
1177 ,
1178 ,
1179 ,
1180 ,
1183 ,
1184 ,
1185 ,
1186 ,
1187 ,
1188 ,
1189 ,
1190 ,
1191 ,
1192 ,
1193 ,
1194 ,
1195 ,
1196 ,
1197 ,
1198 ,
1199 ,
1200 ,
1201 ,
1202 ,
1203 ,
1204 ,
1205 ,
1206 ,
1207 ,
1208 ,
1209 ,
1210 ,
1211 ,
1212 ,
1214 ,
1215 ,
1216 ,
1217 ,
1218 ,
1219 ,
1220 ,
1221 ,
1222 ,
1223 ,
1224 ,
1225 ,
1226 ,
1227 ,
1228 ,
1229 ,
1230 ,
1231 ,
1232 ,
1233 ,
1234 ,
1235 ,
1236 ,
1237 ,
1238 ,
1239 ,
1240 ,
1241 ,
1242 ,
1243 ,
1244 ,
1245 ,
1246 ,
1247 ,
1248 ,
1249 ,
1250 ,
1251 ,
1252 ,
1253 ,
1254 ,
1255 ,
1256 ,
1257 ,
1258 ,
1259 ,
1260 ,
1261 ,
1262 ,
1263 ,
1264 ,
1265 ,
1266 ,
1267 ,
1268 ,
1269 ,
1270 ,
1271 ,
1272 ,
1273 ,
1274 ,
1275 ,
1276 ,
1277 ,
1278 ,
1279 ,
1280 ,
1281 ,
1282 ,
1283 ,
1284 ,
1285 ,
1286 ,
1287 ,
1288 ,
1289 ,
1290 ,
1291 ,
1292 ,
1293 ,
1334 ,
1335 ,
1346 ,
1347 ,
1348 ,
1349 ,
1350 ,
1351 ,
1352 ,
1353 ,
1354 ,
1355 ,
1356 ,
1357 ,
1358 ,
1359 ,
1360 ,
1361 ,
1362 ,
1363 ,
1364 ,
1365 ,
1366 ,
1367 ,
1368 ,
1369 ,
1420 ,
1421 ,
1422 ,
1423 ,
1424 ,
1425 ,
1426 ,
1427 ,
1428 ,
1429 ,
1430 ,
1431 ,
1432 ,
1433 ,
1434 ,
1435 ,
1436 ,
1437 ,
1438 ,
1439 ,
1440 ,
1441 ,
1442 ,
1443 ,
1444 ,
1445 ,
1446 ,
1447 ,
1448 ,
1449 ,
1450 ,
1451 ,
1452 ,
1453 ,
1454 ,
1455 ,
1456 ,
1457 ,
1473 ,
1474 ,
1475 ,
1476 ,
1477 ,
1478 ,
1479 ,
1480 ,
1481 ,
1482 ,
1483 ,
1484 ,
1485 ,
1486 ,
1487 ,
1488 ,
1489 ,
1490 ,
1491 ,
1492 ,
1493 ,
1494 ,
1495 ,
1496 ,
1497 ,
1498 ,
1499 ,
1541 ,
1542 ,
1543 ,
1544 ,
1545 ,
1546 ,
1547 ,
1548 ,
1549 ,
1550 ,
1551 ,
1552 ,
1553 ,
1554 ,
1555 ,
1556 ,
1557 ,
1558 ,
1559 ,
1560 ,
1561 ,
1562 ,
1563 ,
1564 ,
1565 ,
1566 ,
1567 ,
1568 ,
1569 ,
1570 ,
1571 ,
1572 ,
1573 ,
1574 ,
1575 ,
1576 ,
1577 ,
1578 ,
1579 ,
1580 ,
1581 ,
1582 ,
1583 ,
1584 ,
1585 ,
1586 ,
1587 ,
1588 ,
1589 ,
1590 ,
1591 ,
1592 ,
1593 ,
1594 ,
1595 ,
1596 ,
1597 ,
1598 ,
1599 ,
1600 ,
1601 ,
1602 ,
1603 ,
1604 ,
1605 ,
1606 ,
1607 ,
1608 ,
1609 ,
1610 ,
1611 ,
1612 ,
1613 ,
1614 ,
1615 ,
1616 ,
1617 ,
1618 ,
1619 ,
1620 ,
1621 ,
1622 ,
1623 ,
1624 ,
1625 ,
1626 ,
1627 ,
1628 ,
1629 ,
1630 ,
1631 ,
1632 ,
1633 ,
1634 ,
1635 ,
1636 ,
1637 ,
1638 ,
1639 ,
1640 ,
1641 ,
1642 ,
1643 ,
1644 ,
1645 ,
1646 ,
1647 ,
1648 ,
1649 ,
1650 ,
1651 ,
1652 ,
1653 ,
1654 ,
1655 ,
1656 ,
1657 ,
1836 ,
1837 ,
1838 ,
1839 ,
1840 ,
1841 ,
1842 ,
1843 ,
1844 ,
1845 ,
1846 ,
1847 ,
1857 ,
1858 ,
1859 ,
1860 ,
1861 ,
1862 ,
2627 ,
2628 ,
2629 ,
2630 ,
2631 ,
2632 ,
2633 ,
2634 ,
2635 ,
2636 ,
2637 ,
2638 ,
2639 ,
2640 ,
2641 ,
2642 ,
2643 ,
2644 ,
2645 ,
2646 ,
2647 ,
2648 ,
2649 ,
2650 ,
2651 ,
2652 ,
2653 ,
2654 ,
2655 ,
2656 ,
2657 ,
2658 ,
2659 ,
2660 ,
2661 ,
2662 ,
2663 ,
2664 ,
2665 ,
2666 ,
2667 ,
2668 ,
2669 ,
2670 ,
2671 ,
2672 ,
2673 ,
2674 ,
2675 ,
2676 ,
2677 ,
2678 ,
2679 ,
2680 ,
2681 ,
2682 ,
2683 ,
2684 ,
2685 ,
2686 ,
2687 ,
2688 ,
2689 ,
2690 ,
2691 ,
2692 ,
2693 ,
2694 ,
2695 ,
2696 ,
2697 ,
2698 ,
2699 ,
2700 ,
2701 ,
2702 ,
2703 ,
2704 ,
2705 ,
2706 ,
2707 ,
2708 ,
2709 ,
2710 ,
2711 ,
2712 ,
2713 ,
2714 ,
2715 ,
2716 ,
2717 ,
2718 ,
2719 ,
2720 ,
2721 ,
2722 ,
2723 ,
2724 ,
2725 ,
2726 ,
2727 ,
2728 ,
2729 ,
2730 ,
2731 ,
2732 ,
2733 ,
2734 ,
2735 ,
2736 ,
2737 ,
2738 ,
2739 ,
2740 ,
2741 ,
2742 ,
2743 ,
2744 ,
2745 ,
2746 ,
2747 ,
2748 ,
2749 ,
2750 ,
2751 ,
2752 ,
2753 ,
2754 ,
2755 ,
2756 ,
2757 ,
2758 ,
2759 ,
2760 ,
2761 ,
2762 ,
2763 ,
2764 ,
2765 ,
2766 ,
2767 ,
2768 ,
2769 ,
2770 ,
2771 ,
2772 ,
2773 ,
2774 ,
2775 ,
2776 ,
2777 ,
2778 ,
2779 ,
2780 ,
2781 ,
2782 ,
2783 ,
2784 ,
2785 ,
2786 ,
2787 ,
2788 ,
2789 ,
2790 ,
2791 ,
2792 ,
2793 ,
2794 ,
2795 ,
2796 ,
2797 ,
2798 ,
2799 ,
2800 ,
2801 ,
2802 ,
2803 ,
2804 ,
2805 ,
2806 ,
2807 ,
2808 ,
2809 ,
2810 ,
2811 ,
2812 ,
2813 ,
2814 ,
2815 ,
2816 ,
2817 ,
2818 ,
2819 ,
2820 ,
2821 ,
2822 ,
2823 ,
2824 ,
2825 ,
2826 ,
2827 ,
2828 ,
2829 ,
2830 ,
2831 ,
2832 ,
2833 ,
2834 ,
2835 ,
2836 ,
2837 ,
2838 ,
2839 ,
2840 ,
2841 ,
2842 ,
2843 ,
2844 ,
2845 ,
2846 ,
2847 ,
2848 ,
2849 ,
2850 ,
2851 ,
2852 ,
2853 ,
2854 ,
2855 ,
2856 ,
2857 ,
2858 ,
2859 ,
2860 ,
2861 ,
2862 ,
2863 ,
2864 ,
2865 ,
2866 ,
2867 ,
2868 ,
2869 ,
2870 ,
2871 ,
2872 ,
2873 ,
2874 ,
2875 ,
2876 ,
2877 ,
2878 ,
2879 ,
2880 ,
2881 ,
2882 ,
2883 ,
2884 ,
2885 ,
2886 ,
2887 ,
2888 ,
2889 ,
2890 ,
2891 ,
2892 ,
2893 ,
2894 ,
2895 ,
2896 ,
2897 ,
2898 ,
2899 ,
2900 ,
2901 ,
2902 ,
2903 ,
2904 ,
2905 ,
2906 ,
2907 ,
2908 ,
2909 ,
2910 ,
2911 ,
2912 ,
2913 ,
2914 ,
2916 ,
3037 ,
3119 ,
3120 ,
3121 ,
3122 ,
3123 ,
3124 ,
3125 ,
3126 ,
3127 ,
3128 ,
3129 ,
3130 ,
3131 ,
3132 ,
3133 ,
3134 ,
3135 ,
3136 ,
3137 ,
3138 ,
3139 ,
3140 ,
3141 ,
3142 ,
3143 ,
3144 ,
3145 ,
3146 ,
3147 ,
3148 ,
3149 ,
3150 ,
3151 ,
3152 ,
3153 ,
3154 ,
3155 ,
3156 ,
3157 ,
3158 ,
3159 ,
3160 ,
3161 ,
3162 ,
3163 ,
3164 ,
3165 ,
3166 ,
3167 ,
3168 ,
3169 ,
3170 ,
3171 ,
3172 ,
3173 ,
3174 ,
3175 ,
3176 ,
3177 ,
3178 ,
3179 ,
3180 ,
3181 ,
3182 ,
3183 ,
3184 ,
3185 ,
3186 ,
3187 ,
3188 ,
3189 ,
3190 ,
3191 ,
3192 ,
3193 ,
3194 ,
3195 ,
3196 ,
3197 ,
3198 ,
3199 ,
3200 ,
3201 ,
3202 ,
3203 ,
3204 ,
3205 ,
3206 ,
3207 ,
3208 ,
3209 ,
3210 ,
3211 ,
3212 ,
3213 ,
3214 ,
3215 ,
3216 ,
3217 ,
3218 ,
3219 ,
3220 ,
3221 ,
3222 ,
3223 ,
3224 ,
3225 ,
3226 ,
3227 ,
3228 ,
3229 ,
3230 ,
3231 ,
3232 ,
3233 ,
3234 ,
3235 ,
3236 ,
3237 ,
3238 ,
3239 ,
3240 ,
3241 ,
3242 ,
3243 ,
3244 ,
3245 ,
3246 ,
3247 ,
3248 ,
3249 ,
3250 ,
3251 ,
3252 ,
3253 ,
3254 ,
3255 ,
3256 ,
3257 ,
3258 ,
3259 ,
3260 ,
3261 ,
3262 ,
3263 ,
3264 ,
3265 ,
3266 ,
3267 ,
3268 ,
3269 ,
3270 ,
3271 ,
3272 ,
3273 ,
3274 ,
3275 ,
3276 ,
3277 ,
3278 ,
3279 ,
3280 ,
3281 ,
3282 ,
3283 ,
3284 ,
3285 ,
3286 ,
3287 ,
3288 ,
3289 ,
3290 ,
3291 ,
3292 ,
3293 ,
3294 ,
3295 ,
3296 ,
3297 ,
3298 ,
3299 ,
3300 ,
3301 ,
3302 ,
3303 ,
3304 ,
3305 ,
3306 ,
3307 ,
3308 ,
3309 ,
3310 ,
3311 ,
3312 ,
3313 ,
3314 ,
3315 ,
3316 ,
3317 ,
3318 ,
3319 ,
3320 ,
3321 ,
3322 ,
3323 ,
3324 ,
3325 ,
3326 ,
3327 ,
3328 ,
3329 ,
3330 ,
3331 ,
3332 ,
3333 ,
3334 ,
3335 ,
3336 ,
3337 ,
3338 ,
3339 ,
3340 ,
3341 ,
3342 ,
3343 ,
3344 ,
3345 ,
3346 ,
3347 ,
3348 ,
3349 ,
3350 ,
3351 ,
3352 ,
3353 ,
3354 ,
3355 ,
3356 ,
3357 ,
3358 ,
3359 ,
3360 ,
3361 ,
3362 ,
3363 ,
3364 ,
3365 ,
3366 ,
3367 ,
3368 ,
3369 ,
3370 ,
3371 ,
3372 ,
3373 ,
3374 ,
3375 ,
3376 ,
3377 ,
3378 ,
3379 ,
3380 ,
3381 ,
3382 ,
3383 ,
3384 ,
3385 ,
3386 ,
3387 ,
3388 ,
3389 ,
3390 ,
3391 ,
3392 ,
3393 ,
3394 ,
3395 ,
3396 ,
3397 ,
3398 ,
3399 ,
3400 ,
3401 ,
3402 ,
3403 ,
3404 ,
3405 ,
3406 ,
3407 ,
3408 ,
3409 ,
3410 ,
3411 ,
3412 ,
3413 ,
3414 ,
3415 ,
3416 ,
3417 ,
3418 ,
3419 ,
3420 ,
3421 ,
3422 ,
3423 ,
3424 ,
3425 ,
3426 ,
3427 ,
3428 ,
3503 ,
3504 ,
3505 ,
3506 ,
3507 ,
3508 ,
3509 ,
3510 ,
3511 ,
3512 ,
3513 ,
3514 ,
3515 ,
3516 ,
3517 ,
3518 ,
3519 ,
3520 ,
3521 ,
3522 ,
3523 ,
3524 ,
3525 ,
3526 ,
3527 ,
3528 ,
3529 ,
3530 ,
3531 ,
3532 ,
3533 ,
3534 ,
3535 ,
3536 ,
3537 ,
3538 ,
3539 ,
3540 ,
3541 ,
3542 ,
3543 ,
3544 ,
3545 ,
3546 ,
3547 ,
3548 ,
3549 ,
3550 ,
3551 ,
3552 ,
3553 ,
3554 ,
3555 ,
3556 ,
3557 ,
3558 ,
3559 ,
3560 ,
3561 ,
3562 ,
3563 ,
3564 ,
3565 ,
3566 ,
3567 ,
3568 ,
3569 ,
3570 ,
3571 ,
3572 ,
3573 ,
3574 ,
3575 ,
3576 ,
3577 ,
3578 ,
3579 ,
3580 ,
3581 ,
3582 ,
3583 ,
3584 ,
3585 ,
3586 ,
3587 ,
3588 ,
3589 ,
3590 ,
3591 ,
3592 ,
3593 ,
3594 ,
3595 ,
3596 ,
3597 ,
3598 ,
3599 ,
3600 ,
3601 ,
3602 ,
3603 ,
3604 ,
3605 ,
3606 ,
3607 ,
3608 ,
3609 ,
3610 ,
3611 ,
3612 ,
3613 ,
3614 ,
3615 ,
3616 ,
3617 ,
3618 ,
3619 ,
3620 ,
3621 ,
3622 ,
3623 ,
3624 ,
3625 ,
3626 ,
3627 ,
3628 ,
3629 ,
3630 ,
3631 ,
3632 ,
3633 ,
3634 ,
3635 ,
3636 ,
3637 ,
3638 ,
3639 ,
3640 ,
3641 ,
3642 ,
3643 ,
3644 ,
3645 ,
3646 ,
3647 ,
3648 ,
3649 ,
3650 ,
3651 ,
3652 ,
3653 ,
3654 ,
3655 ,
3656 ,
3657 ,
3658 ,
3659 ,
3660 ,
3661 ,
3662 ,
3663 ,
3664 ,
3665 ,
3666 ,
3667 ,
3668 ,
3669 ,
3670 ,
3671 ,
3672 ,
3673 ,
3674 ,
3675 ,
3676 ,
3677 ,
3678 ,
3679 ,
3680 ,
3681 ,
3682 ,
3683 ,
3684 ,
3685 ,
3686 ,
3687 ,
3688 ,
3689 ,
3690 ,
3691 ,
3692 ,
3693 ,
3694 ,
3695 ,
3696 ,
3697 ,
3698 ,
3699 ,
3700 ,
3701 ,
3702 ,
3703 ,
3704 ,
3705 ,
3706 ,
3707 ,
3708 ,
3709 ,
3710 ,
3711 ,
3712 ,
3713 ,
3714 ,
3715 ,
3716 ,
3717 ,
3718 ,
3719 ,
3720 ,
3721 ,
3722 ,
3723 ,
3724 ,
3725 ,
3726 ,
3727 ,
3728 ,
3729 ,
3730 ,
3731 ,
3732 ,
3733 ,
3734 ,
3735 ,
3736 ,
3737 ,
3738 ,
3739 ,
3740 ,
3741 ,
3742 ,
3743 ,
3744 ,
3745 ,
3746 ,
3747 ,
3748 ,
3749 ,
3750 ,
3751 ,
3752 ,
3753 ,
3754 ,
3755 ,
3756 ,
3757 ,
3758 ,
3759 ,
3760 ,
3761 ,
3762 ,
3763 ,
3764 ,
3765 ,
3766 ,
3767 ,
3768 ,
3769 ,
3770 ,
3771 ,
3772 ,
3773 ,
3774 ,
3775 ,
3776 ,
3777 ,
3778 ,
3779 ,
3780 ,
3781 ,
3782 ,
3783 ,
3784 ,
3785 ,
3786 ,
3787 ,
3788 ,
3789 ,
3790 ,
3791 ,
3792 ,
3793 ,
3794 ,
3795 ,
3796 ,
3797 ,
3798 ,
3799 ,
3800 ,
3801 ,
3802 ,
3803 ,
3804 ,
3805 ,
3806 ,
3807 ,
3808 ,
3809 ,
3810 ,
3811 ,
3812 ,
3813 ,
3814 ,
3815 ,
3816 ,
3817 ,
3818 ,
3819 ,
3820 ,
3821 ,
3822 ,
3823 ,
3824 ,
3825 ,
3826 ,
3827 ,
3828 ,
3829 ,
3830 ,
3831 ,
3848 ,
3849 ,
3850 ,
3851 ,
3852 ,
3853 ,
3854 ,
3855 ,
3856 ,
3857 ,
3858 ,
3859 ,
3860 ,
3861 ,
3862 ,
3863 ,
3864 ,
3865 ,
3866 ,
3867 ,
3868 ,
3869 ,
3870 ,
3871 ,
3872 ,
3873 ,
3874 ,
3890 ,
4232 ,
4239 ,
4240 ,
4241 ,
4242 ,
4243 ,
4244 ,
4245 ,
4246 ,
4247 ,
4248 ,
4249 ,
4250 ,
4251 ,
4252 ,
4253 ,
4254 ,
4255 ,
4256 ,
4257 ,
4258 ,
4259 ,
4260 ,
4261 ,
4262 ,
4263 ,
4264 ,
4265 ,
4266 ,
4267 ,
4268 ,
4269 ,
4270 ,
4273 ,
4274 ,
4275 ,
4276 ,
4277 ,
4278 ,
4279 ,
4280 ,
4281 ,
4282 ,
4283 ,
4284 ,
4285 ,
4286 ,
4287 ,
4288 ,
4289 ,
4290 ,
4291 ,
4292 ,
4293 ,
4296 ,
4297 ,
4298 ,
4299 ,
4300 ,
4301 ,
4302 ,
4303 ,
4304 ,
4305 ,
4306 ,
4307 ,
4308 ,
4309 ,
4310 ,
4311 ,
4312 ,
4313 ,
4314 ,
4315 ,
4316 ,
4317 ,
4318 ,
4319 ,
4320 ,
4321 ,
4322 ,
4323 ,
4324 ,
4325 ,
4326 ,
4327 ,
4328 ,
4329 ,
4330 ,
4331 ,
4332 ,
4333 ,
4334 ,
4335 ,
4336 ,
4337 ,
4338 ,
4339 ,
4342 ,
4343 ,
4344 ,
4345 ,
4346 ,
4347 ,
4436 ,
4437 ,
4666 ,
4667 ,
4668 ,
4669 ,
4670 ,
4671 ,
4672 ,
4673 ,
4674 ,
4675 ,
4676 ,
5011 ,
5012 ,
5232 ,
5567 ,
5568 ,
5860 ,
5861 ,
5862 ,
5864 ,
5865 ,
5866 ,
5867 ,
5868 ,
5869 ,
5870 ,
5871 ,
5872 ,
5873 ,
5874 ,
5875 ,
5876 ,
5877 ,
5878 ,
5879 ,
5880 ,
5881 ,
5882 ,
5883 ,
5884 ,
5885 ,
5886 ,
5887 ,
5888 ,
5889 ,
5893 ,
5894 ,
5895 ,
5896 ,
5897 ,
5898 ,
5899 ,
5901 ,
5902 ,
5903 ,
5904 ,
5905 ,
6318 ,
6319 ,
6320 ,
6321 ,
6322 ,
6363 ,
6399 ,
6400 ,
6401 ,
6402 ,
7136 ,
7137 ,
7138 ,
7139 ,
7140 ,
7141 ,
7142 ,
7143 ,
7144 ,
7145 ,
7146 ,
7147 ,
7148 ,
7149 ,
7150 ,
7151 ,
7152 ,
7153 ,
7154 ,
7155 ,
7156 ,
7157 ,
7158 ,
7159 ,
7160 ,
7161 ,
7162 ,
7163 ,
7164 ,
7165 ,
7166 ,
7167 ,
7168 ,
7169 ,
7170 ,
7171 ,
7172 ,
7173 ,
7174 ,
7175 ,
7176 ,
7177 ,
7178 ,
7179 ,
7180 ,
7181 ,
7182 ,
7183 ,
7184 ,
7185 ,
7186 ,
7187 ,
7188 ,
7189 ,
7190 ,
7191 ,
7192 ,
7193 ,
7194 ,
7195 ,
7196 ,
7197 ,
7198 ,
7199 ,
7200 ,
7201 ,
7202 ,
7203 ,
7204 ,
7205 ,
7206 ,
7207 ,
7208 ,
7209 ,
7210 ,
7211 ,
7212 ,
7213 ,
7214 ,
7215 ,
7216 ,
7217 ,
7218 ,
7219 ,
7220 ,
7221 ,
7222 ,
7223 ,
7224 ,
7225 ,
7226 ,
7227 ,
7228 ,
7229 ,
7230 ,
7231 ,
7232 ,
7233 ,
7234 ,
7235 ,
7236 ,
7237 ,
7238 ,
7239 ,
7240 ,
7241 ,
7242 ,
7243 ,
7244 ,
7245 ,
7246 ,
7247 ,
7248 ,
7249 ,
7250 ,
7251 ,
7252 ,
7253 ,
7254 ,
7255 ,
7256 ,
7257 ,
7258 ,
7259 ,
7260 ,
7261 ,
7262 ,
7263 ,
7264 ,
7265 ,
7266 ,
7267 ,
7548 ,
7549 ,
7550 ,
7551 ,
7552 ,
7553 ,
8543 ,
8544 ,
8545 ,
8546 ,
8550 ,
10320 ,
10321 ,
10322 ,
10323 ,
10324 ,
10325 ,
10326 ,
10327 ,
10328 ,
10329 ,
10330 ,
10331 ,
10332 ,
10333 ,
10334 ,
10335 ,
10336 ,
10337 ,
10338 ,
10339 ,
10340 ,
10341 ,
10342 ,
10343 ,
10344 ,
10345 ,
10346 ,
10347 ,
10348 ,
10349 ,
10350 ,
10351 ,
10352 ,
10353 ,
10354 ,
10355 ,
10356 ,
10357 ,
10358 ,
10359 ,
10360 ,
10361 ,
10362 ,
10363 ,
10364 ,
10365 ,
10366 ,
10367 ,
10368 ,
10369 ,
10370 ,
10371 ,
10372 ,
13808 ,
13809 ,
13813 ,
13814 ,
13815 ,
13816 ,
13817 ,
13818 ,
13819 ,
13820 ,
13821 ,
13822 ,
13823 ,
13829 ,
13846 ,
14352 ,
14353 ,
14354 ,
14355 ,
14356 ,
15310 ,
15312 ,
9996 ,
9997 ,
9999 ,
0
};


static const int _stackables_cnt=3453;
static const int _stackables[_stackables_cnt] = {
17,
57,
65,
695,
696,
697,
699,
700,
701,
702,
703,
704,
705,
706,
707,
708,
725,
726,
727,
728,
733,
734,
735,
736,
737,
739,
740,
741,
742,
745,
746,
750,
751,
752,
753,
755,
756,
757,
758,
759,
760,
761,
762,
763,
764,
765,
766,
767,
768,
769,
770,
771,
772,
773,
774,
775,
776,
777,
778,
779,
780,
781,
782,
783,
784,
785,
786,
787,
788,
789,
790,
791,
792,
793,
794,
795,
796,
797,
798,
799,
800,
801,
802,
803,
804,
805,
806,
807,
808,
809,
810,
811,
812,
813,
814,
815,
816,
817,
818,
819,
820,
821,
822,
823,
824,
825,
826,
827,
828,
829,
830,
831,
832,
833,
834,
835,
836,
837,
838,
839,
840,
841,
842,
844,
937,
939,
940,
941,
942,
943,
944,
963,
964,
965,
966,
967,
968,
969,
970,
971,
972,
973,
974,
976,
977,
978,
979,
980,
982,
983,
984,
985,
986,
987,
988,
998,
999,
1000,
1001,
1002,
1003,
1004,
1005,
1006,
1007,
1008,
1009,
1010,
1011,
1012,
1013,
1014,
1015,
1016,
1017,
1018,
1019,
1020,
1021,
1022,
1023,
1024,
1025,
1026,
1027,
1028,
1029,
1030,
1031,
1032,
1033,
1034,
1035,
1036,
1037,
1038,
1039,
1040,
1041,
1042,
1043,
1044,
1045,
1046,
1060,
1061,
1062,
1063,
1064,
1065,
1066,
1067,
1068,
1069,
1070,
1071,
1072,
1073,
1074,
1075,
1076,
1077,
1078,
1079,
1080,
1081,
1082,
1083,
1084,
1085,
1086,
1087,
1088,
1089,
1090,
1091,
1092,
1093,
1094,
1106,
1107,
1108,
1109,
1110,
1111,
1112,
1113,
1114,
1115,
1116,
1117,
1118,
1130,
1131,
1132,
1133,
1134,
1135,
1136,
1137,
1138,
1139,
1140,
1141,
1143,
1144,
1145,
1153,
1154,
1155,
1156,
1157,
1158,
1159,
1160,
1161,
1162,
1163,
1164,
1165,
1166,
1167,
1168,
1169,
1170,
1171,
1172,
1173,
1174,
1175,
1176,
1177,
1178,
1179,
1180,
1183,
1184,
1185,
1186,
1187,
1188,
1189,
1190,
1191,
1192,
1193,
1194,
1195,
1196,
1197,
1198,
1199,
1200,
1201,
1202,
1203,
1204,
1205,
1206,
1207,
1208,
1209,
1210,
1211,
1212,
1214,
1215,
1216,
1217,
1218,
1219,
1220,
1221,
1222,
1223,
1224,
1225,
1226,
1227,
1228,
1229,
1230,
1231,
1232,
1233,
1234,
1235,
1236,
1237,
1238,
1239,
1240,
1241,
1242,
1243,
1244,
1245,
1246,
1247,
1248,
1249,
1250,
1251,
1252,
1253,
1254,
1255,
1256,
1257,
1258,
1259,
1260,
1261,
1262,
1263,
1264,
1265,
1266,
1267,
1268,
1269,
1270,
1271,
1272,
1273,
1274,
1275,
1276,
1277,
1278,
1279,
1280,
1281,
1282,
1283,
1284,
1285,
1286,
1287,
1288,
1289,
1290,
1291,
1292,
1293,
1334,
1335,
1336,
1337,
1338,
1339,
1340,
1341,
1342,
1343,
1344,
1345,
1346,
1347,
1348,
1349,
1350,
1351,
1352,
1353,
1354,
1355,
1356,
1357,
1358,
1359,
1360,
1361,
1362,
1363,
1364,
1365,
1366,
1367,
1368,
1369,
1373,
1374,
1375,
1419,
1420,
1421,
1422,
1423,
1424,
1425,
1426,
1427,
1428,
1429,
1430,
1431,
1432,
1433,
1434,
1435,
1436,
1437,
1438,
1439,
1440,
1441,
1442,
1443,
1444,
1445,
1446,
1447,
1448,
1449,
1450,
1451,
1452,
1453,
1454,
1455,
1456,
1457,
1458,
1459,
1460,
1461,
1462,
1463,
1464,
1465,
1466,
1467,
1468,
1469,
1470,
1473,
1474,
1475,
1476,
1477,
1478,
1479,
1480,
1481,
1482,
1483,
1484,
1485,
1486,
1487,
1488,
1489,
1490,
1491,
1492,
1493,
1494,
1495,
1496,
1497,
1498,
1499,
1500,
1501,
1502,
1503,
1504,
1505,
1538,
1539,
1540,
1541,
1542,
1543,
1544,
1545,
1546,
1547,
1548,
1549,
1550,
1551,
1552,
1553,
1554,
1555,
1556,
1557,
1558,
1559,
1560,
1561,
1562,
1563,
1564,
1565,
1566,
1567,
1568,
1569,
1570,
1571,
1572,
1573,
1574,
1575,
1576,
1577,
1578,
1579,
1580,
1581,
1582,
1583,
1584,
1585,
1586,
1587,
1588,
1589,
1590,
1591,
1592,
1593,
1594,
1595,
1596,
1597,
1598,
1599,
1600,
1601,
1602,
1603,
1604,
1605,
1606,
1607,
1608,
1609,
1610,
1611,
1612,
1613,
1614,
1615,
1616,
1617,
1618,
1619,
1620,
1621,
1622,
1623,
1624,
1625,
1626,
1627,
1628,
1629,
1630,
1631,
1632,
1633,
1634,
1635,
1636,
1637,
1638,
1639,
1640,
1641,
1642,
1643,
1644,
1645,
1646,
1647,
1648,
1649,
1650,
1651,
1652,
1653,
1654,
1655,
1656,
1657,
1658,
1659,
1661,
1662,
1663,
1664,
1674,
1675,
1676,
1677,
1678,
1679,
1680,
1681,
1682,
1683,
1684,
1685,
1686,
1687,
1688,
1689,
1690,
1691,
1692,
1693,
1694,
1695,
1696,
1697,
1698,
1699,
1700,
1701,
1702,
1703,
1704,
1705,
1706,
1707,
1708,
1709,
1710,
1711,
1712,
1713,
1714,
1715,
1716,
1717,
1718,
1719,
1720,
1721,
1722,
1723,
1724,
1725,
1726,
1727,
1728,
1729,
1730,
1731,
1732,
1733,
1734,
1735,
1736,
1737,
1738,
1739,
1740,
1741,
1742,
1743,
1744,
1745,
1746,
1747,
1748,
1749,
1750,
1751,
1752,
1753,
1754,
1755,
1756,
1757,
1758,
1759,
1760,
1761,
1762,
1763,
1764,
1765,
1766,
1767,
1768,
1769,
1770,
1771,
1772,
1773,
1774,
1775,
1776,
1777,
1778,
1779,
1780,
1781,
1782,
1783,
1784,
1785,
1829,
1830,
1831,
1832,
1833,
1834,
1835,
1836,
1837,
1838,
1839,
1840,
1841,
1842,
1843,
1844,
1845,
1846,
1847,
1848,
1849,
1850,
1851,
1852,
1853,
1854,
1855,
1857,
1858,
1859,
1860,
1861,
1862,
1864,
1865,
1866,
1867,
1868,
1869,
1870,
1871,
1872,
1873,
1874,
1875,
1876,
1877,
1878,
1879,
1880,
1881,
1882,
1883,
1884,
1885,
1886,
1887,
1888,
1889,
1890,
1891,
1892,
1893,
1894,
1895,
1896,
1897,
1898,
1899,
1900,
1901,
1902,
1903,
1904,
1905,
1906,
1907,
1908,
1909,
1910,
1911,
1912,
1913,
1914,
1915,
1916,
1917,
1918,
1919,
1920,
1921,
1922,
1923,
1924,
1925,
1926,
1927,
1928,
1929,
1930,
1931,
1932,
1933,
1934,
1935,
1936,
1937,
1938,
1939,
1940,
1941,
1942,
1943,
1944,
1945,
1946,
1947,
1948,
1949,
1950,
1951,
1952,
1953,
1954,
1955,
1956,
1957,
1958,
1959,
1960,
1961,
1962,
1963,
1964,
1965,
1966,
1967,
1968,
1969,
1970,
1971,
1972,
1973,
1974,
1975,
1976,
1977,
1978,
1979,
1980,
1981,
1982,
1983,
1984,
1985,
1986,
1987,
1988,
1989,
1990,
1991,
1992,
1993,
1994,
1995,
1996,
1997,
1998,
1999,
2000,
2001,
2002,
2003,
2004,
2005,
2006,
2007,
2008,
2009,
2010,
2011,
2012,
2013,
2014,
2015,
2016,
2017,
2018,
2019,
2020,
2021,
2022,
2023,
2024,
2025,
2026,
2027,
2028,
2029,
2030,
2031,
2032,
2033,
2034,
2035,
2036,
2037,
2038,
2039,
2040,
2041,
2042,
2043,
2044,
2045,
2046,
2047,
2048,
2049,
2050,
2051,
2052,
2053,
2054,
2055,
2056,
2057,
2058,
2059,
2060,
2061,
2062,
2063,
2064,
2065,
2066,
2067,
2068,
2069,
2070,
2071,
2072,
2073,
2074,
2075,
2076,
2077,
2078,
2079,
2080,
2081,
2082,
2083,
2084,
2085,
2086,
2087,
2088,
2089,
2090,
2091,
2092,
2093,
2094,
2095,
2096,
2097,
2098,
2099,
2100,
2101,
2102,
2103,
2104,
2105,
2106,
2107,
2108,
2109,
2110,
2111,
2112,
2113,
2114,
2115,
2116,
2117,
2118,
2119,
2120,
2121,
2122,
2123,
2124,
2125,
2126,
2127,
2128,
2129,
2130,
2131,
2132,
2133,
2134,
2508,
2509,
2510,
2511,
2512,
2513,
2514,
2515,
2627,
2628,
2629,
2630,
2631,
2632,
2633,
2634,
2635,
2636,
2637,
2638,
2639,
2640,
2641,
2642,
2643,
2644,
2645,
2646,
2647,
2648,
2649,
2650,
2651,
2652,
2653,
2654,
2655,
2656,
2657,
2658,
2659,
2660,
2661,
2662,
2663,
2664,
2665,
2666,
2667,
2668,
2669,
2670,
2671,
2672,
2673,
2674,
2675,
2676,
2677,
2678,
2679,
2680,
2681,
2682,
2683,
2684,
2685,
2686,
2687,
2688,
2689,
2690,
2691,
2692,
2693,
2694,
2695,
2696,
2697,
2698,
2699,
2700,
2701,
2702,
2703,
2704,
2705,
2706,
2707,
2708,
2709,
2710,
2711,
2712,
2713,
2714,
2715,
2716,
2717,
2718,
2719,
2720,
2721,
2722,
2723,
2724,
2725,
2726,
2727,
2728,
2729,
2730,
2731,
2732,
2733,
2734,
2735,
2736,
2737,
2738,
2739,
2740,
2741,
2742,
2743,
2744,
2745,
2746,
2747,
2748,
2749,
2750,
2751,
2752,
2753,
2754,
2755,
2756,
2757,
2758,
2759,
2760,
2761,
2762,
2763,
2764,
2765,
2766,
2767,
2768,
2769,
2770,
2771,
2772,
2773,
2774,
2775,
2776,
2777,
2778,
2779,
2780,
2781,
2782,
2783,
2784,
2785,
2786,
2787,
2788,
2789,
2790,
2791,
2792,
2793,
2794,
2795,
2796,
2797,
2798,
2799,
2800,
2801,
2802,
2803,
2804,
2805,
2806,
2807,
2808,
2809,
2810,
2811,
2812,
2813,
2814,
2815,
2816,
2817,
2818,
2819,
2820,
2821,
2822,
2823,
2824,
2825,
2826,
2827,
2828,
2829,
2830,
2831,
2832,
2833,
2834,
2835,
2836,
2837,
2838,
2839,
2840,
2841,
2842,
2843,
2844,
2845,
2846,
2847,
2848,
2849,
2850,
2851,
2852,
2853,
2854,
2855,
2856,
2857,
2858,
2859,
2860,
2861,
2862,
2863,
2864,
2865,
2866,
2867,
2868,
2869,
2870,
2871,
2872,
2873,
2874,
2875,
2876,
2877,
2878,
2879,
2880,
2881,
2882,
2883,
2884,
2885,
2886,
2887,
2888,
2889,
2890,
2891,
2892,
2893,
2894,
2895,
2896,
2897,
2898,
2899,
2900,
2901,
2902,
2903,
2904,
2905,
2906,
2907,
2908,
2909,
2910,
2911,
2912,
2913,
2914,
2916,
2917,
2918,
2919,
2920,
2921,
2922,
2923,
2924,
2925,
2926,
2927,
2928,
2929,
2930,
2931,
2932,
2933,
2934,
2935,
2936,
2937,
2938,
2939,
2940,
2941,
2942,
2943,
2944,
2945,
2946,
2947,
2948,
2949,
2950,
2951,
2952,
2953,
2954,
2955,
2956,
2957,
2958,
2959,
2960,
2961,
2962,
2963,
2964,
2965,
2966,
2967,
2968,
2969,
3030,
3031,
3037,
3119,
3120,
3121,
3122,
3123,
3124,
3125,
3126,
3127,
3128,
3129,
3130,
3131,
3132,
3133,
3134,
3135,
3136,
3137,
3138,
3139,
3140,
3141,
3142,
3143,
3144,
3145,
3146,
3147,
3148,
3149,
3150,
3151,
3152,
3153,
3154,
3155,
3156,
3157,
3158,
3159,
3160,
3161,
3162,
3163,
3164,
3165,
3166,
3167,
3168,
3169,
3170,
3171,
3172,
3173,
3174,
3175,
3176,
3177,
3178,
3179,
3180,
3181,
3182,
3183,
3184,
3185,
3186,
3187,
3188,
3189,
3190,
3191,
3192,
3193,
3194,
3195,
3196,
3197,
3198,
3199,
3200,
3201,
3202,
3203,
3204,
3205,
3206,
3207,
3208,
3209,
3210,
3211,
3212,
3213,
3214,
3215,
3216,
3217,
3218,
3219,
3220,
3221,
3222,
3223,
3224,
3225,
3226,
3227,
3228,
3229,
3230,
3231,
3232,
3233,
3234,
3235,
3236,
3237,
3238,
3239,
3240,
3241,
3242,
3243,
3244,
3245,
3246,
3247,
3248,
3249,
3250,
3251,
3252,
3253,
3254,
3255,
3256,
3257,
3258,
3259,
3260,
3261,
3262,
3263,
3264,
3265,
3266,
3267,
3268,
3269,
3270,
3271,
3272,
3273,
3274,
3275,
3276,
3277,
3278,
3279,
3280,
3281,
3282,
3283,
3284,
3285,
3286,
3287,
3288,
3289,
3290,
3291,
3292,
3293,
3294,
3295,
3296,
3297,
3298,
3299,
3300,
3301,
3302,
3303,
3304,
3305,
3306,
3307,
3308,
3309,
3310,
3311,
3312,
3313,
3314,
3315,
3316,
3317,
3318,
3319,
3320,
3321,
3322,
3323,
3324,
3325,
3326,
3327,
3328,
3329,
3330,
3331,
3332,
3333,
3334,
3335,
3336,
3337,
3338,
3339,
3340,
3341,
3342,
3343,
3344,
3345,
3346,
3347,
3348,
3349,
3350,
3351,
3352,
3353,
3354,
3355,
3356,
3357,
3358,
3359,
3360,
3361,
3362,
3363,
3364,
3365,
3366,
3367,
3368,
3369,
3370,
3371,
3372,
3373,
3374,
3375,
3376,
3377,
3378,
3379,
3380,
3381,
3382,
3383,
3384,
3385,
3386,
3387,
3388,
3389,
3390,
3391,
3392,
3393,
3394,
3395,
3396,
3397,
3398,
3399,
3400,
3401,
3402,
3403,
3404,
3405,
3406,
3407,
3408,
3409,
3410,
3411,
3412,
3413,
3414,
3415,
3416,
3417,
3418,
3419,
3420,
3421,
3422,
3423,
3424,
3425,
3426,
3427,
3428,
3440,
3441,
3442,
3443,
3470,
3472,
3473,
3474,
3475,
3476,
3477,
3478,
3479,
3480,
3481,
3482,
3483,
3484,
3485,
3486,
3487,
3488,
3489,
3490,
3491,
3492,
3493,
3494,
3495,
3496,
3497,
3498,
3503,
3504,
3505,
3506,
3507,
3508,
3509,
3510,
3511,
3512,
3513,
3514,
3515,
3516,
3517,
3518,
3519,
3520,
3521,
3522,
3523,
3524,
3525,
3526,
3527,
3528,
3529,
3530,
3531,
3532,
3533,
3534,
3535,
3536,
3537,
3538,
3539,
3540,
3541,
3542,
3543,
3544,
3545,
3546,
3547,
3548,
3549,
3550,
3551,
3552,
3553,
3554,
3555,
3556,
3557,
3558,
3559,
3560,
3561,
3562,
3563,
3564,
3565,
3566,
3567,
3568,
3569,
3570,
3571,
3572,
3573,
3574,
3575,
3576,
3577,
3578,
3579,
3580,
3581,
3582,
3583,
3584,
3585,
3586,
3587,
3588,
3589,
3590,
3591,
3592,
3593,
3594,
3595,
3596,
3597,
3598,
3599,
3600,
3601,
3602,
3603,
3604,
3605,
3606,
3607,
3608,
3609,
3610,
3611,
3612,
3613,
3614,
3615,
3616,
3617,
3618,
3619,
3620,
3621,
3622,
3623,
3624,
3625,
3626,
3627,
3628,
3629,
3630,
3631,
3632,
3633,
3634,
3635,
3636,
3637,
3638,
3639,
3640,
3641,
3642,
3643,
3644,
3645,
3646,
3647,
3648,
3649,
3650,
3651,
3652,
3653,
3654,
3655,
3656,
3657,
3658,
3659,
3660,
3661,
3662,
3663,
3664,
3665,
3666,
3667,
3668,
3669,
3670,
3671,
3672,
3673,
3674,
3675,
3676,
3677,
3678,
3679,
3680,
3681,
3682,
3683,
3684,
3685,
3686,
3687,
3688,
3689,
3690,
3691,
3692,
3693,
3694,
3695,
3696,
3697,
3698,
3699,
3700,
3701,
3702,
3703,
3704,
3705,
3706,
3707,
3708,
3709,
3710,
3711,
3712,
3713,
3714,
3715,
3716,
3717,
3718,
3719,
3720,
3721,
3722,
3723,
3724,
3725,
3726,
3727,
3728,
3729,
3730,
3731,
3732,
3733,
3734,
3735,
3736,
3737,
3738,
3739,
3740,
3741,
3742,
3743,
3744,
3745,
3746,
3747,
3748,
3749,
3750,
3751,
3752,
3753,
3754,
3755,
3756,
3757,
3758,
3759,
3760,
3761,
3762,
3763,
3764,
3765,
3766,
3767,
3768,
3769,
3770,
3771,
3772,
3773,
3774,
3775,
3776,
3777,
3778,
3779,
3780,
3781,
3782,
3783,
3784,
3785,
3786,
3787,
3788,
3789,
3790,
3791,
3792,
3793,
3794,
3795,
3796,
3797,
3798,
3799,
3800,
3801,
3802,
3803,
3804,
3805,
3806,
3807,
3808,
3809,
3810,
3811,
3812,
3813,
3814,
3815,
3816,
3817,
3818,
3819,
3820,
3821,
3822,
3823,
3824,
3825,
3826,
3827,
3828,
3829,
3830,
3831,
3839,
3840,
3841,
3842,
3844,
3845,
3846,
3847,
3848,
3849,
3850,
3851,
3852,
3853,
3854,
3855,
3856,
3857,
3858,
3859,
3860,
3861,
3862,
3863,
3864,
3865,
3866,
3867,
3868,
3869,
3870,
3871,
3872,
3873,
3874,
3875,
3876,
3877,
3878,
3879,
3880,
3881,
3882,
3883,
3884,
3885,
3886,
3887,
3888,
3889,
3890,
3926,
3927,
3928,
3929,
3930,
3931,
3932,
3933,
3934,
3935,
3936,
3945,
3946,
3947,
3948,
3949,
3950,
3951,
3952,
3958,
3959,
3960,
3961,
3962,
3963,
3964,
3965,
3966,
3967,
3968,
3969,
3970,
3971,
3972,
3973,
3974,
3975,
3976,
3977,
3978,
3979,
3980,
3981,
3982,
3983,
3984,
3985,
3986,
3987,
3988,
3989,
3990,
3991,
3992,
3993,
3994,
3995,
3996,
3997,
3998,
3999,
4000,
4001,
4002,
4003,
4004,
4005,
4006,
4007,
4008,
4009,
4010,
4011,
4012,
4013,
4014,
4015,
4016,
4017,
4018,
4019,
4020,
4021,
4022,
4023,
4024,
4025,
4026,
4029,
4030,
4031,
4032,
4033,
4034,
4035,
4036,
4037,
4038,
4039,
4040,
4041,
4042,
4043,
4044,
4045,
4046,
4047,
4048,
4049,
4050,
4051,
4052,
4053,
4054,
4055,
4056,
4057,
4058,
4059,
4060,
4061,
4062,
4063,
4064,
4065,
4066,
4067,
4068,
4069,
4070,
4071,
4072,
4073,
4074,
4075,
4076,
4077,
4078,
4079,
4080,
4081,
4082,
4083,
4084,
4085,
4086,
4087,
4088,
4089,
4090,
4091,
4092,
4093,
4094,
4095,
4096,
4097,
4098,
4099,
4100,
4101,
4102,
4103,
4104,
4105,
4106,
4107,
4108,
4109,
4110,
4111,
4112,
4113,
4114,
4115,
4116,
4117,
4118,
4119,
4120,
4121,
4209,
4210,
4211,
4212,
4213,
4214,
4215,
4216,
4217,
4218,
4232,
4239,
4240,
4241,
4242,
4243,
4244,
4245,
4246,
4248,
4249,
4250,
4251,
4252,
4253,
4254,
4255,
4256,
4257,
4258,
4259,
4260,
4261,
4262,
4263,
4264,
4265,
4266,
4267,
4268,
4269,
4270,
4271,
4272,
4273,
4274,
4275,
4276,
4277,
4278,
4279,
4280,
4281,
4282,
4283,
4284,
4285,
4286,
4287,
4288,
4289,
4290,
4291,
4292,
4293,
4294,
4295,
4296,
4297,
4298,
4299,
4300,
4301,
4302,
4303,
4304,
4305,
4306,
4307,
4308,
4309,
4310,
4311,
4312,
4313,
4314,
4315,
4316,
4317,
4319,
4320,
4321,
4323,
4324,
4325,
4326,
4327,
4328,
4329,
4330,
4331,
4332,
4333,
4334,
4335,
4336,
4337,
4338,
4339,
4342,
4343,
4344,
4345,
4346,
4347,
4348,
4349,
4350,
4351,
4352,
4353,
4354,
4355,
4356,
4357,
4358,
4364,
4366,
4367,
4368,
4369,
4370,
4371,
4372,
4373,
4374,
4375,
4376,
4377,
4378,
4379,
4380,
4381,
4382,
4383,
4384,
4385,
4386,
4387,
4388,
4389,
4390,
4391,
4392,
4400,
4401,
4402,
4403,
4404,
4405,
4406,
4407,
4408,
4409,
4410,
4411,
4412,
4413,
4414,
4415,
4416,
4417,
4418,
4419,
4420,
4421,
4433,
4434,
4435,
4436,
4437,
4438,
4439,
4443,
4444,
4666,
4667,
4668,
4669,
4670,
4671,
4672,
4673,
4674,
4675,
4676,
4677,
4678,
4679,
4680,
4936,
4937,
4938,
4939,
4940,
4941,
4942,
4943,
4944,
4945,
4946,
4947,
4948,
4949,
4950,
4951,
4952,
4953,
4954,
4955,
4956,
4957,
4958,
4959,
4960,
4961,
4962,
4963,
4964,
4965,
4966,
4967,
4968,
4969,
4970,
4971,
4972,
4973,
4974,
4975,
4976,
4977,
4978,
4979,
4980,
4981,
4982,
4983,
4984,
4985,
4986,
4987,
4988,
4989,
4990,
4991,
4992,
4993,
4994,
4995,
4996,
4997,
4998,
4999,
5000,
5001,
5002,
5003,
5004,
5005,
5006,
5007,
5008,
5010,
5011,
5012,
5016,
5028,
5126,
5168,
5169,
5192,
5193,
5194,
5195,
5196,
5197,
5198,
5199,
5200,
5201,
5202,
5203,
5204,
5205,
5206,
5207,
5208,
5209,
5210,
5211,
5212,
5213,
5214,
5215,
5218,
5219,
5220,
5230,
5231,
5232,
5234,
5250,
5268,
5269,
5270,
5271,
5272,
5273,
5274,
5275,
5276,
5277,
5278,
5279,
5280,
5281,
5282,
5283,
5332,
5333,
5334,
5335,
5336,
5337,
5338,
5339,
5340,
5341,
5342,
5343,
5344,
5345,
5346,
5347,
5348,
5349,
5350,
5351,
5352,
5353,
5354,
5355,
5356,
5357,
5358,
5359,
5360,
5361,
5362,
5363,
5364,
5365,
5366,
5367,
5368,
5369,
5370,
5371,
5372,
5373,
5374,
5375,
5376,
5377,
5378,
5379,
5380,
5381,
5382,
5383,
5384,
5385,
5386,
5387,
5388,
5389,
5390,
5391,
5392,
5393,
5394,
5395,
5396,
5397,
5398,
5399,
5400,
5401,
5402,
5403,
5404,
5405,
5406,
5407,
5408,
5409,
5410,
5411,
5412,
5413,
5414,
5415,
5416,
5417,
5418,
5419,
5420,
5421,
5422,
5423,
5424,
5425,
5426,
5427,
5428,
5429,
5430,
5431,
5432,
5433,
5434,
5435,
5438,
5439,
5440,
5441,
5442,
5443,
5444,
5445,
5446,
5447,
5448,
5449,
5450,
5451,
5452,
5453,
5454,
5455,
5456,
5457,
5458,
5459,
5460,
5461,
5462,
5463,
5464,
5465,
5466,
5467,
5468,
5469,
5470,
5471,
5472,
5473,
5474,
5475,
5476,
5477,
5478,
5479,
5480,
5481,
5482,
5483,
5484,
5485,
5486,
5487,
5488,
5489,
5490,
5491,
5492,
5493,
5494,
5495,
5496,
5497,
5498,
5499,
5500,
5501,
5502,
5503,
5504,
5505,
5506,
5507,
5508,
5509,
5510,
5511,
5512,
5513,
5514,
5515,
5516,
5517,
5518,
5519,
5520,
5521,
5522,
5523,
5524,
5525,
5526,
5527,
5528,
5529,
5530,
5531,
5532,
5533,
5534,
5535,
5536,
5537,
5538,
5539,
5540,
5541,
5542,
5543,
5544,
5545,
5546,
5547,
5548,
5549,
5550,
5551,
5552,
5553,
5554,
5555,
5556,
5557,
5558,
5559,
5560,
5561,
5562,
5563,
5564,
5565,
5566,
5567,
5568,
5569,
5570,
5571,
5572,
5573,
5574,
5575,
5583,
5584,
5585,
5586,
5587,
5589,
5591,
5592,
5593,
5594,
5595,
5703,
5741,
5742,
5743,
5744,
5745,
5746,
5747,
5748,
5749,
5750,
5751,
5752,
5753,
5754,
5755,
5756,
5757,
5758,
5759,
5760,
5761,
5762,
5763,
5764,
5789,
5790,
5803,
5804,
5805,
5806,
5807,
5858,
5859,
5860,
5861,
5862,
5863,
5864,
5865,
5866,
5867,
5868,
5869,
5870,
5871,
5872,
5873,
5874,
5875,
5876,
5877,
5878,
5879,
5880,
5881,
5882,
5883,
5884,
5885,
5886,
5887,
5888,
5889,
5890,
5893,
5894,
5895,
5896,
5897,
5898,
5899,
5900,
5901,
5902,
5903,
5904,
5905,
5915,
5916,
5917,
5918,
5919,
5920,
5921,
5922,
5923,
5924,
5925,
5926,
5927,
5928,
5929,
5930,
5931,
5932,
5933,
5934,
5935,
5936,
5937,
5938,
5939,
5940,
5941,
5942,
5943,
5944,
5945,
5946,
5947,
5948,
5949,
5950,
5951,
5952,
5953,
5954,
5955,
5956,
5957,
5958,
5961,
5962,
5963,
5964,
5965,
5966,
5967,
5968,
5969,
5970,
5971,
5972,
5973,
5974,
5975,
5976,
5977,
5978,
5979,
5980,
5981,
5982,
5983,
5984,
5985,
5986,
5987,
5988,
5989,
5990,
5991,
5992,
5993,
5994,
5995,
5996,
5997,
5998,
5999,
6000,
6001,
6002,
6003,
6004,
6005,
6006,
6007,
6008,
6009,
6010,
6011,
6012,
6013,
6014,
6015,
6016,
6017,
6018,
6019,
6020,
6021,
6022,
6023,
6024,
6025,
6026,
6027,
6028,
6029,
6030,
6031,
6032,
6033,
6034,
6035,
6036,
6037,
6038,
6039,
6040,
6041,
6042,
6043,
6044,
6045,
6046,
6047,
6051,
6052,
6053,
6054,
6055,
6056,
6057,
6058,
6059,
6060,
6064,
6065,
6066,
6067,
6068,
6069,
6070,
6071,
6072,
6073,
6077,
6078,
6079,
6080,
6081,
6082,
6083,
6084,
6085,
6086,
6090,
6091,
6092,
6093,
6094,
6095,
6096,
6097,
6098,
6099,
6105,
6106,
6107,
6108,
6109,
6110,
6111,
6112,
6113,
6114,
6316,
6318,
6319,
6320,
6321,
6322,
6329,
6330,
6331,
6332,
6333,
6334,
6335,
6336,
6337,
6338,
6339,
6340,
6341,
6342,
6343,
6344,
6345,
6346,
6353,
6360,
6361,
6362,
6363,
6387,
6388,
6389,
6390,
6391,
6392,
6393,
6399,
6400,
6401,
6402,
6403,
6404,
6405,
6406,
6407,
6409,
6410,
6645,
6646,
6647,
7136,
7137,
7138,
7139,
7140,
7141,
7142,
7143,
7144,
7145,
7146,
7147,
7148,
7149,
7150,
7151,
7152,
7153,
7154,
7155,
7156,
7157,
7158,
7159,
7160,
7161,
7162,
7163,
7164,
7165,
7166,
7167,
7168,
7169,
7170,
7171,
7172,
7173,
7174,
7175,
7176,
7177,
7178,
7179,
7180,
7181,
7182,
7183,
7184,
7185,
7186,
7187,
7188,
7189,
7190,
7191,
7192,
7193,
7194,
7195,
7196,
7197,
7198,
7199,
7200,
7201,
7202,
7203,
7204,
7205,
7206,
7207,
7208,
7209,
7210,
7211,
7212,
7213,
7214,
7215,
7216,
7217,
7218,
7219,
7220,
7221,
7222,
7223,
7224,
7225,
7226,
7227,
7228,
7229,
7230,
7231,
7232,
7233,
7234,
7235,
7236,
7237,
7238,
7239,
7240,
7241,
7242,
7243,
7244,
7245,
7246,
7247,
7248,
7249,
7250,
7251,
7252,
7253,
7254,
7255,
7256,
7257,
7258,
7259,
7260,
7261,
7262,
7263,
7264,
7265,
7266,
7267,
7548,
7549,
7550,
7551,
7552,
7553,
7582,
8542,
8543,
8544,
8545,
8546,
9996,
9997,
9999,
10320,
10321,
10322,
10323,
10324,
10325,
10326,
10327,
10328,
10329,
10330,
10331,
10332,
10333,
10334,
10335,
10336,
10337,
10338,
10339,
10340,
10341,
10342,
10343,
10344,
10345,
10346,
10347,
10348,
10349,
10350,
10351,
10352,
10353,
10354,
10355,
10356,
10357,
10358,
10359,
10360,
10361,
10362,
10363,
10364,
10365,
10366,
10367,
10368,
10369,
10370,
10371,
10372,
13808,
13809,
13813,
13814,
13815,
13816,
13817,
13818,
13819,
13820,
13821,
13822,
13823,
13829,
13846,
14352,
14353,
14354,
14355,
14356,
15310,
15312,

8702,
8703,
8704,
8705,
8706,
8707,
6535,
6536,
6537,
6538,
6539,
6540,



0
};

bool check_questitems(int itemID);
bool check_stackable(int itemID);
bool check_stackable_obj(DWORD *pUser, int DobjectID);


static const BYTE _chat_ban_global_cnt=100;
static DWORD _chat_ban_globals[_chat_ban_global_cnt]; 
static const BYTE _chat_ban_gm_cnt=7;
static DWORD _chat_ban_gms[_chat_ban_gm_cnt]; 

DWORD _chat_ban_global_check(DWORD *pUser); 
DWORD _chat_ban_global_set(DWORD charid);

DWORD _chat_ban_gm_check(DWORD *pUser); 
DWORD _chat_ban_gm_set(DWORD charid);


